import{Throttler as e}from"../common/common.js";import{i18n as t}from"../i18n/i18n.js";import{FrameManager as i,OverlayModel as s,PageResourceLoader as r}from"../sdk/sdk.js";import{Widget as o,Tooltip as a,UIUtils as n,Toolbar as l}from"../ui/ui.js";import{DataGrid as h,SortableDataGrid as d}from"../data_grid/data_grid.js";import{InspectorFrontendHost as c}from"../host/host.js";import{TextRange as u}from"../text_utils/text_utils.js";const g={status:"Status",url:"URL",initiator:"Initiator",totalBytes:"Total Bytes",error:"Error",developerResources:"Developer Resources",copyUrl:"Copy URL",copyInitiatorUrl:"Copy initiator URL",pending:"pending",success:"success",failure:"failure",Byte:"1 byte",sBytes:"{PH1} bytes"},p=t.registerUIStrings("developer_resources/DeveloperResourcesListView.js",g),_=t.getLocalizedString.bind(void 0,p);class m extends o.VBox{constructor(e){super(!0),this._nodeForItem=new Map,this._isVisibleFilter=e,this._highlightRegExp=null,this.registerRequiredCSS("developer_resources/developerResourcesListView.css",{enableLegacyPatching:!1});const t=[{id:"status",title:_(g.status),width:"60px",fixedWidth:!0,sortable:!0},{id:"url",title:_(g.url),width:"250px",fixedWidth:!1,sortable:!0},{id:"initiator",title:_(g.initiator),width:"80px",fixedWidth:!1,sortable:!0},{id:"size",title:_(g.totalBytes),width:"80px",fixedWidth:!0,sortable:!0,align:h.Align.Right},{id:"errorMessage",title:_(g.error),width:"200px",fixedWidth:!1,sortable:!0}];this._dataGrid=new d.SortableDataGrid({displayName:_(g.developerResources),columns:t,editCallback:void 0,refreshCallback:void 0,deleteCallback:void 0}),this._dataGrid.setResizeMethod(h.ResizeMethod.Last),this._dataGrid.element.classList.add("flex-auto"),this._dataGrid.addEventListener(h.Events.SortingChanged,this._sortingChanged,this),this._dataGrid.setRowContextMenuCallback(this._populateContextMenu.bind(this));const i=this._dataGrid.asWidget();i.show(this.contentElement),this.setDefaultFocusedChild(i)}_populateContextMenu(e,t){const i=t.item;e.clipboardSection().appendItem(_(g.copyUrl),(()=>{c.InspectorFrontendHostInstance.copyText(i.url)})),i.initiator.initiatorUrl&&e.clipboardSection().appendItem(_(g.copyInitiatorUrl),(()=>{c.InspectorFrontendHostInstance.copyText(i.initiator.initiatorUrl)}))}update(e){let t=!1;const i=this._dataGrid.rootNode();for(const s of e){let e=this._nodeForItem.get(s);e?this._isVisibleFilter(e.item)&&(t=e._refreshIfNeeded()||t):(e=new x(s),this._nodeForItem.set(s,e),this._isVisibleFilter(e.item)&&(i.appendChild(e),t=!0))}t&&this._sortingChanged()}reset(){this._nodeForItem.clear(),this._dataGrid.rootNode().removeChildren()}updateFilterAndHighlight(e){this._highlightRegExp=e;let t=!1;for(const e of this._nodeForItem.values()){const i=this._isVisibleFilter(e.item),s=Boolean(e.parent);i&&e._setHighlight(this._highlightRegExp),i!==s&&(t=!0,i?this._dataGrid.rootNode().appendChild(e):e.remove())}t&&this._sortingChanged()}_sortingChanged(){const e=this._dataGrid.sortColumnId();if(!e)return;const t=x.sortFunctionForColumn(e);t&&this._dataGrid.sortNodes(t,!this._dataGrid.isSortOrderAscending())}}class x extends d.SortableDataGridNode{constructor(e){super(),this.item=e,this._highlightRegExp=null}_setHighlight(e){this._highlightRegExp!==e&&(this._highlightRegExp=e,this.refresh())}_refreshIfNeeded(){return this.refresh(),!0}createCell(e){const t=this.createTD(e);switch(e){case"url":{a.Tooltip.install(t,this.item.url);const i=t.createChild("div","url-outer"),s=i.createChild("div","url-prefix"),r=i.createChild("div","url-suffix"),o=/^(.*)(\/[^/]*)$/.exec(this.item.url);s.textContent=o?o[1]:this.item.url,r.textContent=o?o[2]:"",this._highlightRegExp&&this._highlight(i,this.item.url),this.setCellAccessibleName(this.item.url,t,e);break}case"initiator":{const r=this.item.initiator.initiatorUrl||"";t.textContent=r,a.Tooltip.install(t,r),this.setCellAccessibleName(r,t,e),t.onmouseenter=()=>{const e=i.FrameManager.instance().getFrame(this.item.initiator.frameId||"");e&&e.highlight()},t.onmouseleave=()=>s.OverlayModel.hideDOMNodeHighlight();break}case"status":null===this.item.success?t.textContent=_(g.pending):t.textContent=this.item.success?_(g.success):_(g.failure);break;case"size":{const i=this.item.size;if(null!==i){t.createChild("span").textContent=Number.withThousandsSeparator(i);const s=1===i?_(g.Byte):_(g.sBytes,{PH1:i});this.setCellAccessibleName(s,t,e)}break}case"errorMessage":t.classList.add("error-message"),this.item.errorMessage&&(t.textContent=this.item.errorMessage,this._highlightRegExp&&this._highlight(t,this.item.errorMessage))}return t}_highlight(e,t){if(!this._highlightRegExp)return;const i=this._highlightRegExp.exec(t);if(!i||!i.length)return;const s=new u.SourceRange(i.index,i[0].length);n.highlightRangesWithStyleClass(e,[s],"filter-highlight")}static sortFunctionForColumn(e){const t=e=>null===e?-1:Number(e);switch(e){case"url":return(e,t)=>e.item.url.localeCompare(t.item.url);case"status":return(e,i)=>t(e.item.success)-t(i.item.success);case"size":return(e,i)=>t(e.item.size)-t(i.item.size);case"initiator":return(e,t)=>(e.item.initiator.initiatorUrl||"").localeCompare(t.item.initiator.initiatorUrl||"");case"errorMessage":return(e,t)=>(e.item.errorMessage||"").localeCompare(t.item.errorMessage||"");default:return console.assert(!1,"Unknown sort field: "+e),null}}}const b={enterTextToSearchTheUrlAndError:"Enter text to search the URL and Error columns",loadHttpsDeveloperResources:"Load HTTP(S) developer resources through the inspected target",enableLoadingThroughTarget:"Enable loading through target",resourcesCurrentlyLoading:"{PH1} resources, {PH2} currently loading",resources:"{PH1} resources"},v=t.registerUIStrings("developer_resources/DeveloperResourcesView.js",b),C=t.getLocalizedString.bind(void 0,v);let f;class R extends o.VBox{constructor(){super(!0),this.registerRequiredCSS("developer_resources/developerResourcesView.css",{enableLegacyPatching:!0});const t=this.contentElement.createChild("div","developer-resource-view-toolbar-container"),i=new l.Toolbar("developer-resource-view-toolbar",t);this._textFilterRegExp=null;this._filterInput=new l.ToolbarInput(C(b.enterTextToSearchTheUrlAndError),"",1),this._filterInput.addEventListener(l.ToolbarInput.Event.TextChanged,this._onFilterChanged,this),i.appendToolbarItem(this._filterInput);const s=r.getLoadThroughTargetSetting(),o=new l.ToolbarSettingCheckbox(s,C(b.loadHttpsDeveloperResources),C(b.enableLoadingThroughTarget));i.appendToolbarItem(o),this._coverageResultsElement=this.contentElement.createChild("div","developer-resource-view-results"),this._listView=new m(this._isVisible.bind(this)),this._listView.show(this._coverageResultsElement),this._statusToolbarElement=this.contentElement.createChild("div","developer-resource-view-toolbar-summary"),this._statusMessageElement=this._statusToolbarElement.createChild("div","developer-resource-view-message"),this._throttler=new e.Throttler(100),this._loader=r.PageResourceLoader.instance(),this._loader.addEventListener(r.Events.Update,this._onUpdate,this),this._onUpdate()}static instance(){return f||(f=new R),f}_onUpdate(){this._throttler.schedule(this._update.bind(this))}async _update(){this._listView.reset(),this._listView.update(this._loader.getResourcesLoaded().values()),this._updateStats()}_updateStats(){const{loading:e,resources:t}=this._loader.getNumberOfResources();this._statusMessageElement.textContent=e>0?C(b.resourcesCurrentlyLoading,{PH1:t,PH2:e}):C(b.resources,{PH1:t})}_isVisible(e){return!this._textFilterRegExp||this._textFilterRegExp.test(e.url)||this._textFilterRegExp.test(e.errorMessage||"")}_onFilterChanged(){if(!this._listView)return;const e=this._filterInput.value();this._textFilterRegExp=e?createPlainTextSearchRegex(e,"i"):null,this._listView.updateFilterAndHighlight(this._textFilterRegExp),this._updateStats()}}var w=Object.freeze({__proto__:null,UIStrings:b,DeveloperResourcesView:R});export{w as DeveloperResourcesView};
