import{Worker as t,Settings as e,ResourceType as o}from"../common/common.js";import{StringUtilities as r}from"../platform/platform.js";import{ContentProviderBasedProject as n,DebuggerWorkspaceBinding as i,NetworkProject as a,CSSWorkspaceBinding as s}from"../bindings/bindings.js";import{DebuggerModel as c,CSSModel as u}from"../sdk/sdk.js";import{StaticContentProvider as l,TextRange as d}from"../text_utils/text_utils.js";import{Workspace as p}from"../workspace/workspace.js";const m=Math.min(2,navigator.hardwareConcurrency-1);let h;class g{constructor(){this._taskQueue=[],this._workerTasks=new Map}static instance(){return h||(h=new g),h}_createWorker(){const e=t.WorkerWrapper.fromURL(new URL("../formatter_worker/formatter_worker-entrypoint.js",import.meta.url));return e.onmessage=this._onWorkerMessage.bind(this,e),e.onerror=this._onWorkerError.bind(this,e),e}_processNextTask(){if(!this._taskQueue.length)return;let t=[...this._workerTasks.keys()].find((t=>!this._workerTasks.get(t)));if(!t&&this._workerTasks.size<m&&(t=this._createWorker()),!t)return;const e=this._taskQueue.shift();e&&(this._workerTasks.set(t,e),t.postMessage({method:e.method,params:e.params}))}_onWorkerMessage(t,e){const o=this._workerTasks.get(t);o&&(o.isChunked&&e.data&&!e.data.isLastChunk?o.callback(e.data):(this._workerTasks.set(t,null),this._processNextTask(),o.callback(e.data?e.data:null)))}_onWorkerError(t,e){console.error(e);const o=this._workerTasks.get(t);t.terminate(),this._workerTasks.delete(t);const r=this._createWorker();this._workerTasks.set(r,null),this._processNextTask(),o&&o.callback(null)}_runChunkedTask(t,e,o){const r=new f(t,e,(function(t){if(!t)return void o(!0,null);const e="isLastChunk"in t&&Boolean(t.isLastChunk),r="chunk"in t&&t.chunk;o(e,r)}),!0);this._taskQueue.push(r),this._processNextTask()}_runTask(t,e){return new Promise((o=>{const r=new f(t,e,o,!1);this._taskQueue.push(r),this._processNextTask()}))}format(t,e,o){const r={mimeType:t,content:e,indentString:o};return this._runTask("format",r)}javaScriptIdentifiers(t){return this._runTask("javaScriptIdentifiers",{content:t}).then((t=>t||[]))}evaluatableJavaScriptSubstring(t){return this._runTask("evaluatableJavaScriptSubstring",{content:t}).then((t=>t||""))}parseCSS(t,e){this._runChunkedTask("parseCSS",{content:t},(function(t,o){e(t,o||[])}))}javaScriptOutline(t,e){this._runChunkedTask("javaScriptOutline",{content:t},(function(t,o){e(t,o||[])}))}outlineForMimetype(t,e,o){switch(e){case"text/html":case"text/javascript":return this.javaScriptOutline(t,(function(t,e){o(t,e.map((t=>({line:t.line,column:t.column,title:t.name,subtitle:t.arguments}))))})),!0;case"text/css":return this.parseCSS(t,(function(t,e){o(t,e.map((t=>{const e="selectorText"in t?t.selectorText:t.atRule;return{line:t.lineNumber,subtitle:void 0,column:t.columnNumber,title:e}})))})),!0}return!1}findLastExpression(t){return this._runTask("findLastExpression",{content:t})}findLastFunctionCall(t){return this._runTask("findLastFunctionCall",{content:t})}argumentsList(t){return this._runTask("argumentsList",{content:t})}}class f{constructor(t,e,o,r){this.method=t,this.params=e,this.callback=o,this.isChunked=r}}function _(){return g.instance()}var S=Object.freeze({__proto__:null,FormatterWorkerPool:g,FormatResult:class{constructor(){this.content,this.mapping}},formatterWorkerPool:_,OutlineItem:undefined,FormatMapping:undefined,CSSStyleRule:undefined,CSSAtRule:undefined,CSSRule:undefined,TextRange:undefined});class k{}k.format=function(t,e,o,r){t.isDocumentOrScriptOrStyleSheet()?new C(e,o,r):new T(e,o,r)},k.locationToPosition=function(t,e,o){return(e?t[e-1]+1:0)+o},k.positionToLocation=function(t,e){const o=t.upperBound(e-1);let r;return r=o?e-t[o-1]-1:e,[o,r]};class C{constructor(t,e,o){this._mimeType=t,this._originalContent=e.replace(/\r\n?|[\n\u2028\u2029]/g,"\n").replace(/^\uFEFF/,""),this._callback=o,this._initialize()}async _initialize(){const t=_(),o=e.Settings.instance().moduleSetting("textEditorIndent").get(),r=await t.format(this._mimeType,this._originalContent,o);r?this._didFormatContent(r):this._callback(this._originalContent,new w)}_didFormatContent(t){const e=r.findLineEndingIndexes(this._originalContent),o=r.findLineEndingIndexes(t.content),n=new L(e,o,t.mapping);this._callback(t.content,n)}}class T{constructor(t,e,o){o(e,new w)}}class w{originalToFormatted(t,e){return[t,e||0]}formattedToOriginal(t,e){return[t,e||0]}}class L{constructor(t,e,o){this._originalLineEndings=t,this._formattedLineEndings=e,this._mapping=o}originalToFormatted(t,e){const o=k.locationToPosition(this._originalLineEndings,t,e||0),r=this._convertPosition(this._mapping.original,this._mapping.formatted,o||0);return k.positionToLocation(this._formattedLineEndings,r)}formattedToOriginal(t,e){const o=k.locationToPosition(this._formattedLineEndings,t,e||0),r=this._convertPosition(this._mapping.formatted,this._mapping.original,o);return k.positionToLocation(this._originalLineEndings,r||0)}_convertPosition(t,e,o){const r=t.upperBound(o)-1;let n=e[r]+o-t[r];return r<e.length-1&&n>e[r+1]&&(n=e[r+1]),n}}var F=Object.freeze({__proto__:null,FormatterInterface:k,ScriptFormatter:C,FormatterSourceMapping:class{originalToFormatted(t,e){throw new Error("Not implemented yet.")}formattedToOriginal(t,e){throw new Error("Not implemented yet.")}}});const y=new WeakMap;class b{constructor(t,e,o){this.originalSourceCode=t,this.formattedSourceCode=e,this.mapping=o}originalPath(){return this.originalSourceCode.project().id()+":"+this.originalSourceCode.url()}static _for(t){return y.get(t)||null}}let v=null;class I{constructor(){this._projectId="formatter:",this._project=new n.ContentProviderBasedProject(p.WorkspaceImpl.instance(),this._projectId,p.projectTypes.Formatter,"formatter",!0),this._formattedSourceCodes=new Map,this._scriptMapping=new j,this._styleMapping=new U,p.WorkspaceImpl.instance().addEventListener(p.Events.UISourceCodeRemoved,(t=>{this._onUISourceCodeRemoved(t)}),this)}static instance(){return v||(v=new I),v}async _onUISourceCodeRemoved(t){const e=t.data,o=this._formattedSourceCodes.get(e);o&&o.formatData&&await this._discardFormatData(o.formatData),this._formattedSourceCodes.delete(e)}async discardFormattedUISourceCode(t){const e=b._for(t);return e?(await this._discardFormatData(e),this._formattedSourceCodes.delete(e.originalSourceCode),e.originalSourceCode):null}async _discardFormatData(t){y.delete(t.formattedSourceCode),await this._scriptMapping._setSourceMappingEnabled(t,!1),this._styleMapping._setSourceMappingEnabled(t,!1),this._project.removeFile(t.formattedSourceCode.url())}hasFormatted(t){return this._formattedSourceCodes.has(t)}getOriginalUISourceCode(t){const e=y.get(t);return e?e.originalSourceCode:t}async format(t){const e=this._formattedSourceCodes.get(t);if(e)return e.promise;const o=new Promise((async e=>{const{content:r}=await t.requestContent();k.format(t.contentType(),t.mimeType(),r||"",(async(r,n)=>{const i=this._formattedSourceCodes.get(t);if(!i||i.promise!==o)return;let a,s=0,c="";do{a=`${t.url()}:formatted${c}`,c=":"+s++}while(this._project.uiSourceCodeForURL(a));const u=l.StaticContentProvider.fromString(a,t.contentType(),r),p=this._project.createUISourceCode(a,u.contentType()),m=new b(t,p,n);y.set(p,m),this._project.addUISourceCodeWithProvider(p,u,null,t.mimeType()),await this._scriptMapping._setSourceMappingEnabled(m,!0),await this._styleMapping._setSourceMappingEnabled(m,!0),i.formatData=m;for(const e of t.allDecorations()){const t=e.range(),o=n.originalToFormatted(t.startLine,t.startColumn),r=n.originalToFormatted(t.endLine,t.endColumn);p.addDecoration(new d.TextRange(o[0],o[1],r[0],r[1]),e.type(),e.data())}e(m)}))}));return this._formattedSourceCodes.set(t,{promise:o,formatData:null}),o}}class j{constructor(){i.DebuggerWorkspaceBinding.instance().addSourceMapping(this)}rawLocationToUILocation(t){const e=t.script(),o=e&&b._for(e);if(!o||!e)return null;if(e.isInlineScriptWithSourceURL()){const[r,n]=e.toRelativeLocation(t),[i,a]=o.mapping.originalToFormatted(r,n);return o.formattedSourceCode.uiLocation(i,a)}const[r,n]=o.mapping.originalToFormatted(t.lineNumber,t.columnNumber||0);return o.formattedSourceCode.uiLocation(r,n)}uiLocationToRawLocations(t,e,r){const n=b._for(t);if(!n)return[];const[s,u]=n.mapping.formattedToOriginal(e,r);if(n.originalSourceCode.contentType().isScript()){const t=i.DebuggerWorkspaceBinding.instance().uiLocationToRawLocationsForUnformattedJavaScript(n.originalSourceCode,s,u);return console.assert(t.every((t=>t&&Boolean(t.script())))),t}if(n.originalSourceCode.contentType()===o.resourceTypes.Document){const t=a.NetworkProject.targetForUISourceCode(n.originalSourceCode),e=t&&t.model(c.DebuggerModel);if(e){const t=e.scriptsForSourceURL(n.originalSourceCode.url()).filter((t=>t.isInlineScript()&&!t.hasSourceURL)).map((t=>t.rawLocation(s,u))).filter((t=>Boolean(t)));return console.assert(t.every((t=>t&&Boolean(t.script())))),t}}return[]}async _setSourceMappingEnabled(t,e){const o=this._scriptsForUISourceCode(t.originalSourceCode);if(!o.length)return;if(e)for(const e of o)y.set(e,t);else for(const t of o)y.delete(t);const r=o.map((t=>i.DebuggerWorkspaceBinding.instance().updateLocations(t)));await Promise.all(r)}_scriptsForUISourceCode(t){if(t.contentType()===o.resourceTypes.Document){const e=a.NetworkProject.targetForUISourceCode(t),o=e&&e.model(c.DebuggerModel);if(o){return o.scriptsForSourceURL(t.url()).filter((t=>t.isInlineScript()&&!t.hasSourceURL))}}if(t.contentType().isScript()){console.assert(!y.has(t));return i.DebuggerWorkspaceBinding.instance().uiLocationToRawLocationsForUnformattedJavaScript(t,0,0).map((t=>t.script())).filter((t=>Boolean(t)))}return[]}}const M=new WeakMap;class U{constructor(){s.CSSWorkspaceBinding.instance().addSourceMapping(this),this._headersSymbol=Symbol("Formatter.SourceFormatter.StyleMapping._headersSymbol")}rawLocationToUILocation(t){const e=t.header(),o=e&&b._for(e);if(!o)return null;const r=o.mapping.originalToFormatted(t.lineNumber,t.columnNumber||0);return o.formattedSourceCode.uiLocation(r[0],r[1])}uiLocationToRawLocations(t){const e=b._for(t.uiSourceCode);if(!e)return[];const[o,r]=e.mapping.formattedToOriginal(t.lineNumber,t.columnNumber),n=M.get(e.originalSourceCode);if(!n)return[];return n.filter((t=>t.containsLocation(o,r))).map((t=>new u.CSSLocation(t,o,r)))}async _setSourceMappingEnabled(t,e){const o=t.originalSourceCode,r=this._headersForUISourceCode(o);e?(M.set(o,r),r.forEach((e=>{y.set(e,t)}))):(M.delete(o),r.forEach((t=>{y.delete(t)})));const n=r.map((t=>s.CSSWorkspaceBinding.instance().updateLocations(t)));await Promise.all(n)}_headersForUISourceCode(t){if(t.contentType()===o.resourceTypes.Document){const e=a.NetworkProject.targetForUISourceCode(t),o=e&&e.model(u.CSSModel);if(o)return o.headersForSourceURL(t.url()).filter((t=>t.isInline&&!t.hasSourceURL))}else if(t.contentType().isStyleSheet()){return s.CSSWorkspaceBinding.instance().uiLocationToRawLocations(t.uiLocation(0,0)).map((t=>t.header())).filter((t=>Boolean(t)))}return[]}}var R=Object.freeze({__proto__:null,SourceFormatData:b,SourceFormatter:I});export{S as FormatterWorkerPool,F as ScriptFormatter,R as SourceFormatter};
