import{i18n as t}from"../i18n/i18n.js";import{NetworkManager as e,SDKModel as n,EmulationModel as i}from"../sdk/sdk.js";import{Revealer as o,ObjectWrapper as s,Settings as r}from"../common/common.js";import{userMetrics as l,UserMetrics as a}from"../host/host.js";import{ARIAUtils as d,Toolbar as c,Icon as h,Tooltip as g,InspectorView as u,Widget as p,UIUtils as C,ListWidget as w}from"../ui/ui.js";const m={noThrottling:"No throttling",noInternetConnectivity:"No internet connectivity",lowendMobile:"Low-end mobile",slowGXCpuSlowdown:"Slow 3G & 6x CPU slowdown",midtierMobile:"Mid-tier mobile",fastGXCpuSlowdown:"Fast 3G & 4x CPU slowdown",custom:"Custom",checkNetworkAndPerformancePanels:"Check Network and Performance panels"},b=t.registerUIStrings("mobile_throttling/ThrottlingPresets.js",m),k=t.getLocalizedString.bind(void 0,b);class T{static getNoThrottlingConditions(){return{title:e.NoThrottlingConditions.title,description:k(m.noThrottling),network:e.NoThrottlingConditions,cpuThrottlingRate:T.CPUThrottlingRates.NoThrottling}}static getOfflineConditions(){return{title:e.OfflineConditions.title,description:k(m.noInternetConnectivity),network:e.OfflineConditions,cpuThrottlingRate:T.CPUThrottlingRates.NoThrottling}}static getLowEndMobileConditions(){return{title:k(m.lowendMobile),description:k(m.slowGXCpuSlowdown),network:e.Slow3GConditions,cpuThrottlingRate:T.CPUThrottlingRates.LowEndMobile}}static getMidTierMobileConditions(){return{title:k(m.midtierMobile),description:k(m.fastGXCpuSlowdown),network:e.Fast3GConditions,cpuThrottlingRate:T.CPUThrottlingRates.MidTierMobile}}static getCustomConditions(){return{title:k(m.custom),description:k(m.checkNetworkAndPerformancePanels)}}static getMobilePresets(){return[T.getMidTierMobileConditions(),T.getLowEndMobileConditions(),T.getCustomConditions()]}static getAdvancedMobilePresets(){return[T.getOfflineConditions()]}}T.CPUThrottlingRates={NoThrottling:1,MidTierMobile:4,LowEndMobile:6},T.networkPresets=[e.Fast3GConditions,e.Slow3GConditions,e.OfflineConditions],T.cpuThrottlingPresets=[T.CPUThrottlingRates.NoThrottling,T.CPUThrottlingRates.MidTierMobile,T.CPUThrottlingRates.LowEndMobile];var _=Object.freeze({__proto__:null,UIStrings:m,ThrottlingPresets:T,Conditions:undefined,NetworkThrottlingConditionsGroup:undefined,MobileThrottlingConditionsGroup:undefined,ConditionsList:undefined,PlaceholderConditions:undefined});const f={disabled:"Disabled",presets:"Presets",custom:"Custom"},M=t.registerUIStrings("mobile_throttling/NetworkThrottlingSelector.js",f),v=t.getLocalizedString.bind(void 0,M);class N{constructor(t,n,i){this._populateCallback=t,this._selectCallback=n,this._customNetworkConditionsSetting=i,this._customNetworkConditionsSetting.addChangeListener(this._populateOptions,this),e.MultitargetNetworkManager.instance().addEventListener(e.MultitargetNetworkManager.Events.ConditionsChanged,(()=>{this._networkConditionsChanged()}),this),this._options,this._populateOptions()}revealAndUpdate(){o.reveal(this._customNetworkConditionsSetting),this._networkConditionsChanged()}optionSelected(t){e.MultitargetNetworkManager.instance().setNetworkConditions(t)}_populateOptions(){const t={title:v(f.disabled),items:[e.NoThrottlingConditions]},n={title:v(f.presets),items:T.networkPresets},i={title:v(f.custom),items:this._customNetworkConditionsSetting.get()};if(this._options=this._populateCallback([t,n,i]),!this._networkConditionsChanged())for(let t=this._options.length-1;t>=0;t--)if(this._options[t]){this.optionSelected(this._options[t]);break}}_networkConditionsChanged(){const t=e.MultitargetNetworkManager.instance().networkConditions();for(let e=0;e<this._options.length;++e){const n=this._options[e];if(n&&n.download===t.download&&n.upload===t.upload&&n.latency===t.latency&&n.title===t.title)return this._selectCallback(e),!0}return!1}}var S=Object.freeze({__proto__:null,UIStrings:f,NetworkThrottlingSelector:N});const P={sS:"{PH1}: {PH2}",add:"Add…",addS:"Add {PH1}",offline:"Offline",forceDisconnectedFromNetwork:"Force disconnected from network",throttling:"Throttling",cpuThrottlingIsEnabled:"CPU throttling is enabled",cpuThrottling:"CPU throttling",noThrottling:"No throttling",dSlowdown:"{PH1}× slowdown"},I=t.registerUIStrings("mobile_throttling/ThrottlingManager.js",P),x=t.getLocalizedString.bind(void 0,I);let R;class E extends s.ObjectWrapper{constructor(){super(),this._cpuThrottlingRate=T.CPUThrottlingRates.NoThrottling,this._cpuThrottlingControls=new Set,this._cpuThrottlingRates=T.cpuThrottlingPresets,this._customNetworkConditionsSetting=r.Settings.instance().moduleSetting("customNetworkConditions"),this._currentNetworkThrottlingConditions=e.NoThrottlingConditions,this._lastNetworkThrottlingConditions,e.MultitargetNetworkManager.instance().addEventListener(e.MultitargetNetworkManager.Events.ConditionsChanged,(()=>{this._lastNetworkThrottlingConditions=this._currentNetworkThrottlingConditions,this._currentNetworkThrottlingConditions=e.MultitargetNetworkManager.instance().networkConditions()})),n.TargetManager.instance().observeModels(i.EmulationModel,this)}static instance(t={forceNew:null}){const{forceNew:e}=t;return R&&!e||(R=new E),R}decorateSelectWithNetworkThrottling(t){let e=[];const n=new N((function(n){t.removeChildren(),e=[];for(let i=0;i<n.length;++i){const o=n[i],s=t.createChild("optgroup");s.label=o.title;for(const t of o.items){const n=t.title,i=new Option(n,n);d.setAccessibleName(i,x(P.sS,{PH1:o.title,PH2:n})),s.appendChild(i),e.push(t)}if(i===n.length-1){const t=new Option(x(P.add),x(P.add));d.setAccessibleName(t,x(P.addS,{PH1:o.title})),s.appendChild(t),e.push(null)}}return e}),(function(e){t.selectedIndex!==e&&(t.selectedIndex=e)}),this._customNetworkConditionsSetting);return t.addEventListener("change",(function(){if(t.selectedIndex===t.options.length-1)n.revealAndUpdate();else{const i=e[t.selectedIndex];i&&n.optionSelected(i)}}),!1),n}createOfflineToolbarCheckbox(){const t=new c.ToolbarCheckbox(x(P.offline),x(P.forceDisconnectedFromNetwork),function(){t.checked()?e.MultitargetNetworkManager.instance().setNetworkConditions(e.OfflineConditions):e.MultitargetNetworkManager.instance().setNetworkConditions(this._lastNetworkThrottlingConditions)}.bind(this));return e.MultitargetNetworkManager.instance().addEventListener(e.MultitargetNetworkManager.Events.ConditionsChanged,(function(){t.setChecked(e.MultitargetNetworkManager.instance().networkConditions()===e.OfflineConditions)})),t.setChecked(e.MultitargetNetworkManager.instance().networkConditions()===e.OfflineConditions),t}createMobileThrottlingButton(){const t=new c.ToolbarMenuButton((function(t){for(let o=0;o<e.length;++o){const s=e[o];s&&(s.title===T.getCustomConditions().title&&s.description===T.getCustomConditions().description||t.defaultSection().appendCheckboxItem(x(s.title),i.optionSelected.bind(i,s),n===o))}}));t.setTitle(x(P.throttling)),t.setGlyph(""),t.turnIntoSelect(),t.setDarkText();let e=[],n=-1;const i=new A((function(t){e=[];for(const n of t){for(const t of n.items)e.push(t);e.push(null)}return e}),(function(i){n=i;const o=e[i];o&&(t.setText(o.title),t.setTitle(o.description))}));return t}cpuThrottlingRate(){return this._cpuThrottlingRate}setCPUThrottlingRate(t){this._cpuThrottlingRate=t;for(const t of n.TargetManager.instance().models(i.EmulationModel))t.setCPUThrottlingRate(this._cpuThrottlingRate);let e=null;this._cpuThrottlingRate!==T.CPUThrottlingRates.NoThrottling&&(l.actionTaken(a.Action.CpuThrottlingEnabled),e=h.Icon.create("smallicon-warning"),g.Tooltip.install(e,x(P.cpuThrottlingIsEnabled)));const o=this._cpuThrottlingRates.indexOf(this._cpuThrottlingRate);for(const t of this._cpuThrottlingControls)t.setSelectedIndex(o);u.InspectorView.instance().setPanelIcon("timeline",e),this.dispatchEventToListeners(U.RateChanged,this._cpuThrottlingRate)}modelAdded(t){this._cpuThrottlingRate!==T.CPUThrottlingRates.NoThrottling&&t.setCPUThrottlingRate(this._cpuThrottlingRate)}modelRemoved(t){}createCPUThrottlingSelector(){const t=new c.ToolbarComboBox((t=>this.setCPUThrottlingRate(this._cpuThrottlingRates[t.target.selectedIndex])),x(P.cpuThrottling));this._cpuThrottlingControls.add(t);const e=this._cpuThrottlingRate;for(let n=0;n<this._cpuThrottlingRates.length;++n){const i=this._cpuThrottlingRates[n],o=1===i?x(P.noThrottling):x(P.dSlowdown,{PH1:i}),s=t.createOption(o);t.addOption(s),e===i&&t.setSelectedIndex(n)}return t}}const U={RateChanged:Symbol("RateChanged")};function L(){return E.instance()}var H=Object.freeze({__proto__:null,UIStrings:P,ThrottlingManager:E,Events:U,ActionDelegate:class{handleAction(t,n){return"network-conditions.network-online"===n?(e.MultitargetNetworkManager.instance().setNetworkConditions(e.NoThrottlingConditions),!0):"network-conditions.network-low-end-mobile"===n?(e.MultitargetNetworkManager.instance().setNetworkConditions(e.Slow3GConditions),!0):"network-conditions.network-mid-tier-mobile"===n?(e.MultitargetNetworkManager.instance().setNetworkConditions(e.Fast3GConditions),!0):"network-conditions.network-offline"===n&&(e.MultitargetNetworkManager.instance().setNetworkConditions(e.OfflineConditions),!0)}},throttlingManager:L});const y={disabled:"Disabled",presets:"Presets",advanced:"Advanced"},O=t.registerUIStrings("mobile_throttling/MobileThrottlingSelector.js",y),B=t.getLocalizedString.bind(void 0,O);class A{constructor(t,n){this._populateCallback=t,this._selectCallback=n,L().addEventListener(U.RateChanged,this._conditionsChanged,this),e.MultitargetNetworkManager.instance().addEventListener(e.MultitargetNetworkManager.Events.ConditionsChanged,this._conditionsChanged,this),this._options=this._populateOptions(),this._conditionsChanged()}optionSelected(t){e.MultitargetNetworkManager.instance().setNetworkConditions(t.network),L().setCPUThrottlingRate(t.cpuThrottlingRate)}_populateOptions(){const t={title:B(y.disabled),items:[T.getNoThrottlingConditions()]},e={title:B(y.presets),items:T.getMobilePresets()},n={title:B(y.advanced),items:T.getAdvancedMobilePresets()};return this._populateCallback([t,e,n])}_conditionsChanged(){const t=e.MultitargetNetworkManager.instance().networkConditions(),n=L().cpuThrottlingRate();for(let e=0;e<this._options.length;++e){const i=this._options[e];if(i&&"network"in i&&i.network===t&&i.cpuThrottlingRate===n)return void this._selectCallback(e)}const i=T.getCustomConditions();for(let t=0;t<this._options.length;++t){const e=this._options[t];if(e&&e.title===i.title&&e.description===i.description)return void this._selectCallback(t)}}}var j=Object.freeze({__proto__:null,UIStrings:y,MobileThrottlingSelector:A});const G={networkThrottlingIsEnabled:"Network throttling is enabled",requestsMayBeRewrittenByLocal:"Requests may be rewritten by local overrides",requestsMayBeBlocked:"Requests may be blocked"},z=t.registerUIStrings("mobile_throttling/NetworkPanelIndicator.js",G),D=t.getLocalizedString.bind(void 0,z);var q=Object.freeze({__proto__:null,UIStrings:G,NetworkPanelIndicator:class{constructor(){if(!u.InspectorView.instance().hasPanel("network"))return;const t=e.MultitargetNetworkManager.instance();function n(){let n=null;t.isThrottling()?(n=h.Icon.create("smallicon-warning"),g.Tooltip.install(n,D(G.networkThrottlingIsEnabled))):e.MultitargetNetworkManager.instance().isIntercepting()?(n=h.Icon.create("smallicon-warning"),g.Tooltip.install(n,D(G.requestsMayBeRewrittenByLocal))):t.isBlocking()&&(n=h.Icon.create("smallicon-warning"),g.Tooltip.install(n,D(G.requestsMayBeBlocked))),u.InspectorView.instance().setPanelIcon("network",n)}t.addEventListener(e.MultitargetNetworkManager.Events.ConditionsChanged,n),t.addEventListener(e.MultitargetNetworkManager.Events.BlockedPatternsChanged,n),t.addEventListener(e.MultitargetNetworkManager.Events.InterceptorsChanged,n),n()}}});const F={networkThrottlingProfiles:"Network Throttling Profiles",addCustomProfile:"Add custom profile...",dms:"{PH1}ms",profileName:"Profile Name",download:"Download",upload:"Upload",latency:"Latency",kbs:"kb/s",optional:"optional",ms:"ms",profileNameCharactersLengthMust:"Profile Name characters length must be between 1 to {PH1} inclusive",sMustBeANumberBetweenSkbsToSkbs:"{PH1} must be a number between {PH2}kb/s to {PH3}kb/s inclusive",latencyMustBeAnIntegerBetweenSms:"Latency must be an integer between {PH1}ms to {PH2}ms inclusive",dskbs:"{PH1}{PH2}kB/s",fsmbs:"{PH1}{PH2}MB/s"},V=t.registerUIStrings("mobile_throttling/ThrottlingSettingsTab.js",F),X=t.getLocalizedString.bind(void 0,V);class W extends p.VBox{constructor(){super(!0),this.registerRequiredCSS("mobile_throttling/throttlingSettingsTab.css",{enableLegacyPatching:!0});const t=this.contentElement.createChild("div","header");t.textContent=X(F.networkThrottlingProfiles),d.markAsHeading(t,1);const e=C.createTextButton(X(F.addCustomProfile),this._addButtonClicked.bind(this),"add-conditions-button");this.contentElement.appendChild(e),this._list=new w.ListWidget(this),this._list.element.classList.add("conditions-list"),this._list.registerRequiredCSS("mobile_throttling/throttlingSettingsTab.css",{enableLegacyPatching:!0}),this._list.show(this.contentElement),this._customSetting=r.Settings.instance().moduleSetting("customNetworkConditions"),this._customSetting.addChangeListener(this._conditionsUpdated,this),this.setDefaultFocusedElement(e)}wasShown(){super.wasShown(),this._conditionsUpdated()}_conditionsUpdated(){this._list.clear();const t=this._customSetting.get();for(let e=0;e<t.length;++e)this._list.appendItem(t[e],!0);this._list.appendSeparator()}_addButtonClicked(){this._list.addNewItem(this._customSetting.get().length,{title:"",download:-1,upload:-1,latency:0})}renderItem(t,e){const n=document.createElement("div");n.classList.add("conditions-list-item");const i=n.createChild("div","conditions-list-text conditions-list-title").createChild("div","conditions-list-title-text");return i.textContent=t.title,g.Tooltip.install(i,t.title),n.createChild("div","conditions-list-separator"),n.createChild("div","conditions-list-text").textContent=J(t.download),n.createChild("div","conditions-list-separator"),n.createChild("div","conditions-list-text").textContent=J(t.upload),n.createChild("div","conditions-list-separator"),n.createChild("div","conditions-list-text").textContent=X(F.dms,{PH1:t.latency}),n}removeItemRequested(t,e){const n=this._customSetting.get();n.splice(e,1),this._customSetting.set(n)}commitEdit(t,e,n){t.title=e.control("title").value.trim();const i=e.control("download").value.trim();t.download=i?125*parseInt(i,10):-1;const o=e.control("upload").value.trim();t.upload=o?125*parseInt(o,10):-1;const s=e.control("latency").value.trim();t.latency=s?parseInt(s,10):0;const r=this._customSetting.get();n&&r.push(t),this._customSetting.set(r)}beginEdit(t){const e=this._createEditor();return e.control("title").value=t.title,e.control("download").value=t.download<=0?"":String(t.download/125),e.control("upload").value=t.upload<=0?"":String(t.upload/125),e.control("latency").value=t.latency?String(t.latency):"",e}_createEditor(){if(this._editor)return this._editor;const t=new w.Editor;this._editor=t;const e=t.contentElement(),n=e.createChild("div","conditions-edit-row"),i=n.createChild("div","conditions-list-text conditions-list-title"),o=X(F.profileName);i.textContent=o,n.createChild("div","conditions-list-separator conditions-list-separator-invisible");const s=n.createChild("div","conditions-list-text"),r=X(F.download);s.textContent=r,n.createChild("div","conditions-list-separator conditions-list-separator-invisible");const l=n.createChild("div","conditions-list-text"),a=X(F.upload);l.textContent=a,n.createChild("div","conditions-list-separator conditions-list-separator-invisible");const c=n.createChild("div","conditions-list-text"),h=X(F.latency);c.textContent=h;const g=e.createChild("div","conditions-edit-row"),u=t.createInput("title","text","",(function(t,e,n){const i=n.value.trim(),o=i.length>0&&i.length<=49;if(!o){const t=X(F.profileNameCharactersLengthMust,{PH1:49});return{valid:o,errorMessage:t}}return{valid:o,errorMessage:void 0}}));d.setAccessibleName(u,o),g.createChild("div","conditions-list-text conditions-list-title").appendChild(u),g.createChild("div","conditions-list-separator conditions-list-separator-invisible");let p=g.createChild("div","conditions-list-text");const C=t.createInput("download","text",X(F.kbs),_);p.appendChild(C),d.setAccessibleName(C,r);const m=p.createChild("div","conditions-edit-optional"),b=X(F.optional);m.textContent=b,d.setDescription(C,b),g.createChild("div","conditions-list-separator conditions-list-separator-invisible"),p=g.createChild("div","conditions-list-text");const k=t.createInput("upload","text",X(F.kbs),_);d.setAccessibleName(k,a),p.appendChild(k);p.createChild("div","conditions-edit-optional").textContent=b,d.setDescription(k,b),g.createChild("div","conditions-list-separator conditions-list-separator-invisible"),p=g.createChild("div","conditions-list-text");const T=t.createInput("latency","text",X(F.ms),(function(t,e,n){const i=1e6,o=n.value.trim(),s=Number(o),r=Number.isInteger(s)&&s>=0&&s<=i;if(!r){const t=X(F.latencyMustBeAnIntegerBetweenSms,{PH1:0,PH2:i});return{valid:r,errorMessage:t}}return{valid:r,errorMessage:void 0}}));d.setAccessibleName(T,h),p.appendChild(T);return p.createChild("div","conditions-edit-optional").textContent=b,d.setDescription(T,b),t;function _(t,e,n){const i=1e7,o=n.value.trim(),s=Number(o),r=n.getAttribute("aria-label"),l=!Number.isNaN(s)&&s>=0&&s<=i;if(!l){return{valid:l,errorMessage:X(F.sMustBeANumberBetweenSkbsToSkbs,{PH1:r,PH2:0,PH3:i})}}return{valid:l,errorMessage:void 0}}}}function J(t,e){if(t<0)return"";const n=t/125,i=e?"":" ";if(n<1e3)return X(F.dskbs,{PH1:n,PH2:i});if(n<1e4){const t=(n/1e3).toFixed(1);return X(F.fsmbs,{PH1:t,PH2:i})}return X(F.fsmbs,{PH1:n/1e3|0,PH2:i})}var K=Object.freeze({__proto__:null,UIStrings:F,ThrottlingSettingsTab:W,throughputText:J});export{j as MobileThrottlingSelector,q as NetworkPanelIndicator,S as NetworkThrottlingSelector,H as ThrottlingManager,_ as ThrottlingPresets,K as ThrottlingSettingsTab};
