import{Console as e,Settings as t,SegmentedRange as s,UIString as a}from"../common/common.js";import{ArrayUtilities as r}from"../platform/platform.js";import{Runtime as i}from"../root/root.js";import{TracingModel as n,SDKModel as o,CPUProfileDataModel as l,LayerTreeBase as d,PaintProfiler as c}from"../sdk/sdk.js";class h{static generateTracingEventsFromCpuProfile(e,t){const s=e.idleNode,a=e.programNode||null,r=e.gcNode,i=e.samples||[],o=e.timestamps,l=[],d=new Map;d.set(a,[]);for(let a=0;a<i.length;++a){let c=e.nodeByIndex(a);if(!c){console.error(`Node with unknown id ${i[a]} at index ${a}`);continue}if(c===r||c===s)continue;let h=d.get(c);if(!h){h=new Array(c.depth+1),d.set(c,h);for(let e=0;c.parent;c=c.parent)h[e++]=c}const m=new n.Event(n.DevToolsTimelineEventCategory,_.JSSample,n.Phase.Instant,o[a],t);m.args.data={stackTrace:h},l.push(m)}return l}static generateJSFrameEvents(e,t){const s=[],a=[],r=[];let i=0,o=!1;const{showAllEvents:l,showRuntimeCallStats:d,showNativeFunctions:c}=t;function m(e,t){if(r.length){const s=r[r.length-1];e<s&&(console.error(`Child stack is shallower (${e}) than the parent stack (${s}) at ${t}`),e=s)}a.length<e&&(console.error("Trying to truncate higher than the current stack size at "+t),e=a.length);for(let e=0;e<a.length;++e)a[e].setEndTime(t);a.length=e}function p(e){const t=_,i=e.name===t.JSSample?e.args.data.stackTrace.slice().reverse():a.map((e=>e.args.data));!function(e){if(l)return;let t=null,s=0;for(let r=0;r<e.length;++r){const i=e[r],n=i.url,o=n&&n.startsWith("native ");if(!c&&o)continue;const l=h.isNativeRuntimeFrame(i);if(l&&(a=i.functionName,!d||!Boolean(h.nativeGroup(a))))continue;const m=l?h.nativeGroup(i.functionName):null;t&&t===m||(t=m,e[s++]=i)}var a;e.length=s}(i);const o=e.endTime||e.startTime,u=Math.min(i.length,a.length);let p;for(p=r[r.length-1]||0;p<u;++p){const e=i[p],t=a[p].args.data;if(T=t,(g=e).scriptId!==T.scriptId||g.functionName!==T.functionName||g.lineNumber!==T.lineNumber)break;a[p].setEndTime(Math.max(a[p].endTime,o))}var g,T;for(m(p,e.startTime);p<i.length;++p){const r=i[p],l=new n.Event(n.DevToolsTimelineEventCategory,t.JSFrame,n.Phase.Complete,e.startTime,e.thread);l.ordinal=e.ordinal,l.addArgs({data:r}),l.setEndTime(o),a.push(l),s.push(l)}}const g=e.find(n.TracingModel.isTopLevelEvent),T=g?g.startTime:0;return u.forEachEvent(e,(function(e){o&&(m(r.pop(),e.startTime),o=!1),e.ordinal=++i,p(e),r.push(a.length)}),(function(e){m(r.pop(),e.endTime)}),(function(e,t){if(e.ordinal=++i,t&&function(e){switch(e.name){case _.RunMicrotasks:case _.FunctionCall:case _.EvaluateScript:case _.EvaluateModule:case _.EventDispatch:case _.V8Execute:return!0}return!1}(t)||o)p(e);else if(e.name===_.JSSample&&0===a.length){o=!0;const t=a.length;p(e),r.push(t)}}),T),s}static isNativeRuntimeFrame(e){return"native V8Runtime"===e.url}static nativeGroup(e){return e.startsWith("Parse")?h.NativeGroups.Parse:e.startsWith("Compile")||e.startsWith("Recompile")?h.NativeGroups.Compile:null}static buildTraceProfileFromCpuProfile(e,t,s,a){const r=[];if(s&&p("TracingStartedInPage",{data:{sessionId:"1"}},0,0,"M"),a||(a=ls`Thread ${t}`),p(n.MetadataEvent.ThreadName,{name:a},0,0,"M","__metadata"),!e)return r;const i=new Map,o=e.nodes;for(let e=0;e<o.length;++e)i.set(o[e].id,o[e]);let l=null,d=null,c=e.startTime,h=0;const m=e.samples,u=e.timeDeltas;for(let e=0;e<m.length;++e){h=c,c+=u[e];const t=i.get(m[e]).callFrame.functionName;"(idle)"!==t?(l||(l=p("MessageLoop::RunTask",{},h,0,"X","toplevel")),"(program)"===t?d&&(d.dur=h-d.ts,d=null):d||(d=p("FunctionCall",{data:{sessionId:"1"}},h))):_()}return _(),p("CpuProfile",{data:{cpuProfile:e}},e.endTime,0,"I"),r;function _(){l&&(l.dur=h-l.ts),d&&(d.dur=h-d.ts),l=null,d=null}function p(e,s,a,i,n,o){const l={cat:o||"disabled-by-default-devtools.timeline",name:e,ph:n||"X",pid:1,tid:t,ts:a,args:s};return i&&(l.dur=i),r.push(l),l}}}h.NativeGroups={Compile:"Compile",Parse:"Parse"};var m=Object.freeze({__proto__:null,TimelineJSProfileProcessor:h});class u{constructor(){this._isGenericTrace,this._tracks,this._namedTracks,this._inspectedTargetEvents,this._timeMarkerEvents,this._sessionId,this._mainFrameNodeId,this._pageFrames,this._cpuProfiles,this._workerIdByThread,this._requestsFromBrowser,this._mainFrame,this._minimumRecordTime=0,this._maximumRecordTime=0,this._totalBlockingTime=0,this._estimatedTotalBlockingTime=0,this._asyncEventTracker,this._invalidationTracker,this._layoutInvalidate,this._lastScheduleStyleRecalculation,this._paintImageEventByPixelRefId,this._lastPaintForLayer,this._lastRecalculateStylesEvent,this._currentScriptEvent,this._eventStack,this._knownInputEvents,this._browserFrameTracking,this._persistentIds,this._legacyCurrentPage,this._reset(),this._resetProcessingState(),this._currentTaskLayoutAndRecalcEvents=[],this._tracingModel=null}static forEachEvent(e,t,s,a,r,i,o){r=r||0,i=i||1/0;const l=[];for(let d=u._topLevelEventEndingAfter(e,r);d<e.length;++d){const c=e[d];if((c.endTime||c.startTime)<r)continue;if(c.startTime>=i)break;if(n.TracingModel.isAsyncPhase(c.phase)||n.TracingModel.isFlowPhase(c.phase))continue;let h=l[l.length-1];for(;h&&void 0!==h.endTime&&h.endTime<=c.startTime;)l.pop(),s(h),h=l[l.length-1];o&&!o(c)||(c.duration?(t(c),l.push(c)):a&&a(c,l[l.length-1]||null))}for(;l.length;){const e=l.pop();e&&s(e)}}static _topLevelEventEndingAfter(e,t){let s=e.upperBound(t,((e,t)=>e-t.startTime))-1;for(;s>0&&!n.TracingModel.isTopLevelEvent(e[s]);)s--;return Math.max(s,0)}isMarkerEvent(e){const t=_;switch(e.name){case t.TimeStamp:return!0;case t.MarkFirstPaint:case t.MarkFCP:return Boolean(this._mainFrame)&&e.args.frame===this._mainFrame.frameId&&Boolean(e.args.data);case t.MarkDOMContent:case t.MarkLoad:case t.MarkLCPCandidate:case t.MarkLCPInvalidate:return Boolean(e.args.data.isMainFrame);default:return!1}}isInteractiveTimeEvent(e){return e.name===_.InteractiveTime}isLayoutShiftEvent(e){return e.name===_.LayoutShift}isUserTimingEvent(e){return e.categoriesString===u.Category.UserTiming}isParseHTMLEvent(e){return e.name===_.ParseHTML}isLCPCandidateEvent(e){return e.name===_.MarkLCPCandidate&&Boolean(e.args.data.isMainFrame)}isLCPInvalidateEvent(e){return e.name===_.MarkLCPInvalidate&&Boolean(e.args.data.isMainFrame)}isFCPEvent(e){return e.name===_.MarkFCP&&Boolean(this._mainFrame)&&e.args.frame===this._mainFrame.frameId}isLongRunningTask(e){return e.name===_.Task&&S.forEvent(e).warning===u.WarningType.LongTask}isNavigationStartEvent(e){return e.name===_.NavigationStart}isMainFrameNavigationStartEvent(e){return this.isNavigationStartEvent(e)&&e.args.data.isLoadingMainFrame&&e.args.data.documentLoaderURL}static globalEventId(e,t){const s=e.args.data||e.args.beginData,a=s&&s[t];return a?`${e.thread.process().id()}.${a}`:""}static eventFrameId(e){const t=e.args.data||e.args.beginData;return t&&t.frame||""}cpuProfiles(){return this._cpuProfiles}totalBlockingTime(){return-1===this._totalBlockingTime?{time:this._estimatedTotalBlockingTime,estimated:!0}:{time:this._totalBlockingTime,estimated:!1}}targetByEvent(e){const t=this._workerIdByThread.get(e.thread),s=o.TargetManager.instance().mainTarget();return t?o.TargetManager.instance().targetById(t):s}navStartTimes(){return this._tracingModel?this._tracingModel.navStartTimes():new Map}setEvents(e){this._reset(),this._resetProcessingState(),this._tracingModel=e,this._minimumRecordTime=e.minimumRecordTime(),this._maximumRecordTime=e.maximumRecordTime();const t=[];for(const s of e.sortedProcesses())if("Renderer"===s.name())for(const e of s.sortedThreads()){const s=e.removeEventsByName(_.LayoutShift);t.push(...s)}if(this._processSyncBrowserEvents(e),this._browserFrameTracking)this._processThreadsForBrowserFrames(e);else{const t=this._processMetadataEvents(e);this._isGenericTrace=!t,t?this._processMetadataAndThreads(e,t):this._processGenericTrace(e)}this._inspectedTargetEvents.sort(n.Event.compareStartTime),this._processAsyncBrowserEvents(e),this._buildGPUEvents(e),this._buildLoadingEvents(e,t),this._resetProcessingState()}_processGenericTrace(e){let t=n.TracingModel.browserMainThread(e);!t&&e.sortedProcesses().length&&(t=e.sortedProcesses()[0].sortedThreads()[0]);for(const s of e.sortedProcesses())for(const a of s.sortedThreads())this._processThreadEvents(e,[{from:0,to:1/0}],a,a===t,!1,!0,null)}_processMetadataAndThreads(e,t){let s=0;for(let a=0,r=t.page.length;a<r;a++){const i=t.page[a],n=i.thread.process(),o=a+1<r?t.page[a+1].startTime:1/0;if(s!==o){this._legacyCurrentPage=i.args.data&&i.args.data.page;for(const a of n.sortedThreads()){let r=null;if(a.name()===u.WorkerThreadName||a.name()===u.WorkerThreadNameLegacy){const e=t.workers.find((e=>e.args.data.workerThreadId===a.id()&&(e.args.data.sessionId===this._sessionId||Boolean(this._pageFrames.get(u.eventFrameId(e))))));if(!e)continue;const s=e.args.data.workerId;s&&this._workerIdByThread.set(a,s),r=e.args.data.url||""}this._processThreadEvents(e,[{from:s,to:o}],a,a===i.thread,Boolean(r),!0,r)}s=o}}}_processThreadsForBrowserFrames(e){const t=new Map;for(const e of this._pageFrames.values())for(let s=0;s<e.processes.length;s++){const a=e.processes[s].processId;let r=t.get(a);r||(r=[],t.set(a,r));const i=s===e.processes.length-1?e.deletedTime||1/0:e.processes[s+1].time;r.push({from:e.processes[s].time,to:i,main:!e.parent,url:e.processes[s].url})}const s=e.devToolsMetadataEvents();for(const a of e.sortedProcesses()){const r=t.get(a.id());if(!r)continue;r.sort(((e,t)=>e.from-t.from||e.to-t.to));const i=[];let n=null,o=null,l=!1;for(const e of r){const t=i[i.length-1];!t||e.from>t.to?i.push({from:e.from,to:e.to}):t.to=e.to,e.main&&(l=!0),e.url&&(e.main&&(o=e.url),n=e.url)}for(const t of a.sortedThreads())if(t.name()===u.RendererMainThreadName)this._processThreadEvents(e,i,t,!0,!1,l,l?o:n);else if(t.name()===u.WorkerThreadName||t.name()===u.WorkerThreadNameLegacy){const r=s.find((e=>e.name===u.DevToolsMetadataEvent.TracingSessionIdForWorker&&(e.thread.process()===a&&(e.args.data.workerThreadId===t.id()&&Boolean(this._pageFrames.get(u.eventFrameId(e)))))));if(!r)continue;this._workerIdByThread.set(t,r.args.data.workerId||""),this._processThreadEvents(e,i,t,!1,!0,!1,r.args.data.url||"")}else this._processThreadEvents(e,i,t,!1,!1,!1,null)}}_processMetadataEvents(t){const s=t.devToolsMetadataEvents(),a=[],r=[];for(const e of s)if(e.name===u.DevToolsMetadataEvent.TracingStartedInPage){a.push(e),e.args.data&&e.args.data.persistentIds&&(this._persistentIds=!0);(e.args.data&&e.args.data.frames||[]).forEach((t=>this._addPageFrame(e,t))),this._mainFrame=this.rootFrames()[0]}else e.name===u.DevToolsMetadataEvent.TracingSessionIdForWorker?r.push(e):e.name===u.DevToolsMetadataEvent.TracingStartedInBrowser&&(console.assert(!this._mainFrameNodeId,"Multiple sessions in trace"),this._mainFrameNodeId=e.args.frameTreeNodeId);if(!a.length)return null;const i=a[0].args.sessionId||a[0].args.data.sessionId;this._sessionId=i;const o=new Set;const l={page:a.filter((function(e){let t=e.args;t.data&&(t=t.data);const s=t.sessionId;return s===i||(o.add(s),!1)})).sort(n.Event.compareStartTime),workers:r.sort(n.Event.compareStartTime)};return o.size&&e.Console.instance().error("Timeline recording was started in more than one page simultaneously. Session id mismatch: "+this._sessionId+" and "+[...o]+"."),l}_processSyncBrowserEvents(e){const t=n.TracingModel.browserMainThread(e);t&&t.events().forEach(this._processBrowserEvent,this)}_processAsyncBrowserEvents(e){const t=n.TracingModel.browserMainThread(e);t&&this._processAsyncEvents(t,[{from:0,to:1/0}])}_buildGPUEvents(e){const t=e.threadByName("GPU Process","CrGpuMain");if(!t)return;const s=_.GPUTask,a=this._ensureNamedTrack(g.GPU);a.thread=t,a.events=t.events().filter((e=>e.name===s))}_buildLoadingEvents(e,t){const s=e.threadByName("Renderer","CrRendererMain");if(!s)return;const a=this._ensureNamedTrack(g.Experience);a.thread=s,a.events=t;for(const e of a.events)if(e.categoriesString="experience",e.name===_.LayoutShift){const t=e.args.data||e.args.beginData||{};S.forEvent(e).backendNodeId=t.impacted_nodes&&t.impacted_nodes.length>0?t.impacted_nodes[0].node_id:0}}_resetProcessingState(){this._asyncEventTracker=new I,this._invalidationTracker=new y,this._layoutInvalidate={},this._lastScheduleStyleRecalculation={},this._paintImageEventByPixelRefId={},this._lastPaintForLayer={},this._lastRecalculateStylesEvent=null,this._currentScriptEvent=null,this._eventStack=[],this._knownInputEvents=new Set,this._browserFrameTracking=!1,this._persistentIds=!1,this._legacyCurrentPage=null}_extractCpuProfile(t,s){const a=s.events();let r,i=null,n=a[a.length-1];if(n&&n.name===_.CpuProfile){const e=n.args.data;r=e&&e.cpuProfile,i=this.targetByEvent(n)}if(!r){if(n=a.find((e=>e.name===_.Profile)),!n)return null;i=this.targetByEvent(n);const s=t.profileGroup(n);if(!s)return e.Console.instance().error("Invalid CPU profile format."),null;r={startTime:1e3*n.startTime,endTime:0,nodes:[],samples:[],timeDeltas:[],lines:[]};for(const t of s.children){const s=t.args.data;"startTime"in s&&(r.startTime=1e3*t.startTime),"endTime"in s&&(r.endTime=1e3*t.startTime);const a=s.cpuProfile||{},i=a.samples||[],n=s.lines||Array(i.length).fill(0);if(r.nodes.push(...a.nodes||[]),r.lines.push(...n),r.samples&&r.samples.push(...i),r.timeDeltas&&r.timeDeltas.push(...s.timeDeltas||[]),r.samples&&r.timeDeltas&&r.samples.length!==r.timeDeltas.length)return e.Console.instance().error("Failed to parse CPU profile."),null}if(!r.endTime&&r.timeDeltas){const e=r.timeDeltas;r.endTime=e.reduce(((e,t)=>e+t),r.startTime)}}try{const e=r,t=new l.CPUProfileDataModel(e,i);return this._cpuProfiles.push(t),t}catch(t){e.Console.instance().error("Failed to parse CPU profile.")}return null}_injectJSFrameEvents(e,s){const a=this._extractCpuProfile(e,s);let o=s.events();const l=a?h.generateTracingEventsFromCpuProfile(a,s):null;if(l&&l.length&&(o=r.mergeOrdered(o,l,n.Event.orderedCompareStartTime)),l||o.some((e=>e.name===_.JSSample))){const e=h.generateJSFrameEvents(o,{showAllEvents:i.experiments.isEnabled("timelineShowAllEvents"),showRuntimeCallStats:i.experiments.isEnabled("timelineV8RuntimeCallStats"),showNativeFunctions:t.Settings.instance().moduleSetting("showNativeFunctionsInJSProfile").get()});e&&e.length&&(o=r.mergeOrdered(e,o,n.Event.orderedCompareStartTime))}return o}_processThreadEvents(e,t,s,a,r,i,o){const l=new p;l.name=s.name()||ls`Thread ${s.id()}`,l.type=g.Other,l.thread=s,a?(l.type=g.MainThread,l.url=o||"",l.forMainFrame=i):r?(l.type=g.Worker,l.url=o||"",l.name=l.url?ls`Worker — ${l.url}`:ls`Dedicated Worker`):s.name().startsWith("CompositorTileWorker")&&(l.type=g.Raster),this._tracks.push(l);const d=this._injectJSFrameEvents(e,s);this._eventStack=[];const c=this._eventStack;if(r){const e=d.find((e=>e.name===_.Profile));if(e){const t=this.targetByEvent(e);t&&(l.name=ls`Worker: ${t.name()} — ${l.url}`)}}for(const e of t){let t=d.lowerBound(e.from,((e,t)=>e-t.startTime));for(;t<d.length;t++){const s=d[t];if(s.startTime>=e.to)break;this.isInteractiveTimeEvent(s)&&-1===this._totalBlockingTime&&(this._totalBlockingTime=s.args.args.total_blocking_time_ms);const r=s.name===_.Task&&s.duration&&s.duration>50;a&&r&&s.duration&&(this._estimatedTotalBlockingTime+=s.duration-50);let i=c[c.length-1];for(;i&&void 0!==i.endTime&&i.endTime<=s.startTime;)c.pop(),i=c[c.length-1];if(this._processEvent(s)){if(!n.TracingModel.isAsyncPhase(s.phase)&&s.duration){if(c.length){const e=c[c.length-1];e&&(e.selfTime-=s.duration,e.selfTime<0&&this._fixNegativeDuration(e,s))}s.selfTime=s.duration,c.length||l.tasks.push(s),c.push(s)}this.isMarkerEvent(s)&&this._timeMarkerEvents.push(s),l.events.push(s),this._inspectedTargetEvents.push(s)}}}this._processAsyncEvents(s,t)}_fixNegativeDuration(e,t){e.selfTime<-.001&&console.error(`Children are longer than parent at ${e.startTime} (${(t.startTime-this.minimumRecordTime()).toFixed(3)} by ${(-e.selfTime).toFixed(3)}`),e.selfTime=0}_processAsyncEvents(e,t){const s=e.asyncEvents(),a=new Map;function i(e){return a.has(e)||a.set(e,[]),a.get(e)}for(const e of t){let t=s.lowerBound(e.from,(function(e,t){return e-t.startTime}));for(;t<s.length;++t){const a=s[t];if(a.startTime>=e.to)break;if(a.hasCategory(u.Category.Console))i(g.Console).push(a);else if(a.hasCategory(u.Category.UserTiming))i(g.Timings).push(a);else if(a.name!==_.Animation)if(a.hasCategory(u.Category.LatencyInfo)||a.name===_.ImplSideFling){const e=a.steps[a.steps.length-1];if(!e)throw new Error("AsyncEvent.steps access is out of bounds.");if(e.phase!==n.Phase.AsyncEnd)continue;const t=e.args.data;if(a.causedFrame=Boolean(t&&t.INPUT_EVENT_LATENCY_RENDERER_SWAP_COMPONENT),a.hasCategory(u.Category.LatencyInfo)){if(e.id&&!this._knownInputEvents.has(e.id))continue;if(a.name===_.InputLatencyMouseMove&&!a.causedFrame)continue;if(t.is_coalesced)continue;const s=t.INPUT_EVENT_LATENCY_RENDERER_MAIN_COMPONENT;if(s){const e=s.time/1e3;S.forEvent(a.steps[0]).timeWaitingForMainThread=e-a.steps[0].startTime}}i(g.Input).push(a)}else;else i(g.Animation).push(a)}}for(const[t,s]of a){const a=this._ensureNamedTrack(t);a.thread=e,a.asyncEvents=r.mergeOrdered(a.asyncEvents,s,n.Event.compareStartTime)}}_processEvent(e){const t=_,s=this._eventStack;if(!s.length){if(this._currentTaskLayoutAndRecalcEvents&&this._currentTaskLayoutAndRecalcEvents.length){if(this._currentTaskLayoutAndRecalcEvents.reduce(((e,t)=>void 0===t.duration?e:e+t.duration),0)>u.Thresholds.ForcedLayout)for(const e of this._currentTaskLayoutAndRecalcEvents){S.forEvent(e).warning=e.name===t.Layout?u.WarningType.ForcedLayout:u.WarningType.ForcedStyle}}this._currentTaskLayoutAndRecalcEvents=[]}this._currentScriptEvent&&void 0!==this._currentScriptEvent.endTime&&e.startTime>this._currentScriptEvent.endTime&&(this._currentScriptEvent=null);const a=e.args.data||e.args.beginData||{},r=S.forEvent(e);if(a.stackTrace&&(r.stackTrace=a.stackTrace),r.stackTrace&&e.name!==t.JSSample)for(let e=0;e<r.stackTrace.length;++e)--r.stackTrace[e].lineNumber,--r.stackTrace[e].columnNumber;let i=u.eventFrameId(e);const n=s[s.length-1];switch(!i&&n&&(i=S.forEvent(n).frameId),r.frameId=i||this._mainFrame&&this._mainFrame.frameId||"",this._asyncEventTracker.processEvent(e),this.isMarkerEvent(e)&&this._ensureNamedTrack(g.Timings),e.name){case t.ResourceSendRequest:case t.WebSocketCreate:r.setInitiator(s[s.length-1]||null),r.url=a.url;break;case t.ScheduleStyleRecalculation:this._lastScheduleStyleRecalculation[a.frame]=e;break;case t.UpdateLayoutTree:case t.RecalculateStyles:this._invalidationTracker.didRecalcStyle(e),e.args.beginData&&r.setInitiator(this._lastScheduleStyleRecalculation[e.args.beginData.frame]),this._lastRecalculateStylesEvent=e,this._currentScriptEvent&&this._currentTaskLayoutAndRecalcEvents.push(e);break;case t.ScheduleStyleInvalidationTracking:case t.StyleRecalcInvalidationTracking:case t.StyleInvalidatorInvalidationTracking:case t.LayoutInvalidationTracking:this._invalidationTracker.addInvalidation(new f(e));break;case t.InvalidateLayout:{let t=e;const s=a.frame;!this._layoutInvalidate[s]&&this._lastRecalculateStylesEvent&&void 0!==this._lastRecalculateStylesEvent.endTime&&this._lastRecalculateStylesEvent.endTime>e.startTime&&(t=S.forEvent(this._lastRecalculateStylesEvent).initiator()),this._layoutInvalidate[s]=t;break}case t.Layout:{this._invalidationTracker.didLayout(e);const t=e.args.beginData.frame;r.setInitiator(this._layoutInvalidate[t]),e.args.endData&&(r.backendNodeId=e.args.endData.rootNode),this._layoutInvalidate[t]=null,this._currentScriptEvent&&this._currentTaskLayoutAndRecalcEvents.push(e);break}case t.Task:void 0!==e.duration&&e.duration>u.Thresholds.LongTask&&(r.warning=u.WarningType.LongTask);break;case t.EventDispatch:void 0!==e.duration&&e.duration>u.Thresholds.RecurringHandler&&(r.warning=u.WarningType.LongHandler);break;case t.TimerFire:case t.FireAnimationFrame:void 0!==e.duration&&e.duration>u.Thresholds.RecurringHandler&&(r.warning=u.WarningType.LongRecurringHandler);break;case t.FunctionCall:"string"==typeof a.scriptName&&(a.url=a.scriptName),"number"==typeof a.scriptLine&&(a.lineNumber=a.scriptLine);case t.EvaluateScript:case t.CompileScript:"number"==typeof a.lineNumber&&--a.lineNumber,"number"==typeof a.columnNumber&&--a.columnNumber;case t.RunMicrotasks:this._currentScriptEvent||(this._currentScriptEvent=e);break;case t.SetLayerTreeId:{if(this._sessionId&&a.sessionId&&this._sessionId===a.sessionId){this._mainFrameLayerTreeId=a.layerTreeId;break}const t=u.eventFrameId(e),s=this._pageFrames.get(t);if(!s||s.parent)return!1;this._mainFrameLayerTreeId=a.layerTreeId;break}case t.Paint:{if(this._invalidationTracker.didPaint(e),r.backendNodeId=a.nodeId,!a.layerId)break;const t=a.layerId;this._lastPaintForLayer[t]=e;break}case t.DisplayItemListSnapshot:case t.PictureSnapshot:{const s=this._findAncestorEvent(t.UpdateLayer);if(!s||s.args.layerTreeId!==this._mainFrameLayerTreeId)break;const a=this._lastPaintForLayer[s.args.layerId];a&&(S.forEvent(a).picture=e);break}case t.ScrollLayer:r.backendNodeId=a.nodeId;break;case t.PaintImage:r.backendNodeId=a.nodeId,r.url=a.url;break;case t.DecodeImage:case t.ResizeImage:{let e=this._findAncestorEvent(t.PaintImage);if(!e){const s=this._findAncestorEvent(t.DecodeLazyPixelRef);e=s&&this._paintImageEventByPixelRefId[s.args.LazyPixelRef]}if(!e)break;const s=S.forEvent(e);r.backendNodeId=s.backendNodeId,r.url=s.url;break}case t.DrawLazyPixelRef:{const s=this._findAncestorEvent(t.PaintImage);if(!s)break;this._paintImageEventByPixelRefId[e.args.LazyPixelRef]=s;const a=S.forEvent(s);r.backendNodeId=a.backendNodeId,r.url=a.url;break}case t.FrameStartedLoading:if(r.frameId!==e.args.frame)return!1;break;case t.MarkLCPCandidate:r.backendNodeId=a.nodeId;break;case t.MarkDOMContent:case t.MarkLoad:{const t=u.eventFrameId(e);if(!this._pageFrames.has(t))return!1;break}case t.CommitLoad:{if(this._browserFrameTracking)break;const t=u.eventFrameId(e),s=Boolean(a.isMainFrame),r=this._pageFrames.get(t);if(r)r.update(e.startTime,a);else if(this._persistentIds){if(s)return!1;if(!this._addPageFrame(e,a))return!1}else if(a.page&&a.page!==this._legacyCurrentPage)return!1;if(s){const e=this._pageFrames.get(t);e&&(this._mainFrame=e)}break}case t.FireIdleCallback:void 0!==e.duration&&e.duration>a.allottedMilliseconds+u.Thresholds.IdleCallbackAddon&&(r.warning=u.WarningType.IdleDeadlineExceeded)}return!0}_processBrowserEvent(e){if(e.name!==_.LatencyInfoFlow)if(e.name!==_.ResourceWillSendRequest){if(e.hasCategory(n.DevToolsMetadataEventCategory)&&e.args.data){const t=e.args.data;if(e.name===u.DevToolsMetadataEvent.TracingStartedInBrowser){if(!t.persistentIds)return;this._browserFrameTracking=!0,this._mainFrameNodeId=t.frameTreeNodeId;return void(t.frames||[]).forEach((e=>{const t=e.parent&&this._pageFrames.get(e.parent);if(e.parent&&!t)return;let s=this._pageFrames.get(e.frame);s||(s=new T(e),this._pageFrames.set(s.frameId,s),t?t.addChild(s):this._mainFrame=s),s.update(this._minimumRecordTime,e)}))}if(e.name===u.DevToolsMetadataEvent.FrameCommittedInBrowser&&this._browserFrameTracking){let s=this._pageFrames.get(t.frame);if(!s){const e=t.parent&&this._pageFrames.get(t.parent);if(!e)return;s=new T(t),this._pageFrames.set(s.frameId,s),e.addChild(s)}return void s.update(e.startTime,t)}if(e.name===u.DevToolsMetadataEvent.ProcessReadyInBrowser&&this._browserFrameTracking){const e=this._pageFrames.get(t.frame);return void(e&&e.processReady(t.processPseudoId,t.processId))}if(e.name===u.DevToolsMetadataEvent.FrameDeletedInBrowser&&this._browserFrameTracking){const s=this._pageFrames.get(t.frame);return void(s&&(s.deletedTime=e.startTime))}}}else{const t=e.args.data.requestId;"string"==typeof t&&this._requestsFromBrowser.set(t,e)}else{const t=e.args.frameTreeNodeId;"number"==typeof t&&t===this._mainFrameNodeId&&e.bind_id&&this._knownInputEvents.add(e.bind_id)}}_ensureNamedTrack(e){let t=this._namedTracks.get(e);return t||(t=new p,t.type=e,this._tracks.push(t),this._namedTracks.set(e,t),t)}_findAncestorEvent(e){for(let t=this._eventStack.length-1;t>=0;--t){const s=this._eventStack[t];if(s.name===e)return s}return null}_addPageFrame(e,t){const s=t.parent&&this._pageFrames.get(t.parent);if(t.parent&&!s)return!1;const a=new T(t);return this._pageFrames.set(a.frameId,a),a.update(e.startTime,t),s&&s.addChild(a),!0}_reset(){this._isGenericTrace=!1,this._tracks=[],this._namedTracks=new Map,this._inspectedTargetEvents=[],this._timeMarkerEvents=[],this._sessionId=null,this._mainFrameNodeId=null,this._cpuProfiles=[],this._workerIdByThread=new WeakMap,this._pageFrames=new Map,this._requestsFromBrowser=new Map,this._minimumRecordTime=0,this._maximumRecordTime=0,this._totalBlockingTime=-1,this._estimatedTotalBlockingTime=0}isGenericTrace(){return this._isGenericTrace}tracingModel(){return this._tracingModel}minimumRecordTime(){return this._minimumRecordTime}maximumRecordTime(){return this._maximumRecordTime}inspectedTargetEvents(){return this._inspectedTargetEvents}tracks(){return this._tracks}isEmpty(){return 0===this.minimumRecordTime()&&0===this.maximumRecordTime()}timeMarkerEvents(){return this._timeMarkerEvents}rootFrames(){return Array.from(this._pageFrames.values()).filter((e=>!e.parent))}pageURL(){return this._mainFrame&&this._mainFrame.url||""}pageFrameById(e){return e&&this._pageFrames.get(e)||null}networkRequests(){if(this.isGenericTrace())return[];const e=new Map,t=[],s=[],a=_,r=new Set([a.ResourceWillSendRequest,a.ResourceSendRequest,a.ResourceReceiveResponse,a.ResourceReceivedData,a.ResourceFinish,a.ResourceMarkAsCached]),i=this.inspectedTargetEvents();for(let e=0;e<i.length;++e){const t=i[e];if(!r.has(t.name))continue;const s=u.globalEventId(t,"requestId");if(t.name===a.ResourceSendRequest&&this._requestsFromBrowser.has(t.args.data.requestId)){const e=t.args.data.requestId,a=this._requestsFromBrowser.get(e);a&&n(a,s)}n(t,s)}function n(a,r){let i=e.get(r);i?i.addEvent(a):(i=new v(a),e.set(r,i),i.startTime?t.push(i):s.push(i))}return s.concat(t)}}const _={Task:"RunTask",Program:"Program",EventDispatch:"EventDispatch",GPUTask:"GPUTask",Animation:"Animation",RequestMainThreadFrame:"RequestMainThreadFrame",BeginFrame:"BeginFrame",NeedsBeginFrameChanged:"NeedsBeginFrameChanged",BeginMainThreadFrame:"BeginMainThreadFrame",ActivateLayerTree:"ActivateLayerTree",DrawFrame:"DrawFrame",DroppedFrame:"DroppedFrame",HitTest:"HitTest",ScheduleStyleRecalculation:"ScheduleStyleRecalculation",RecalculateStyles:"RecalculateStyles",UpdateLayoutTree:"UpdateLayoutTree",InvalidateLayout:"InvalidateLayout",Layout:"Layout",LayoutShift:"LayoutShift",UpdateLayer:"UpdateLayer",UpdateLayerTree:"UpdateLayerTree",PaintSetup:"PaintSetup",Paint:"Paint",PaintImage:"PaintImage",Rasterize:"Rasterize",RasterTask:"RasterTask",ScrollLayer:"ScrollLayer",CompositeLayers:"CompositeLayers",InteractiveTime:"InteractiveTime",ScheduleStyleInvalidationTracking:"ScheduleStyleInvalidationTracking",StyleRecalcInvalidationTracking:"StyleRecalcInvalidationTracking",StyleInvalidatorInvalidationTracking:"StyleInvalidatorInvalidationTracking",LayoutInvalidationTracking:"LayoutInvalidationTracking",ParseHTML:"ParseHTML",ParseAuthorStyleSheet:"ParseAuthorStyleSheet",TimerInstall:"TimerInstall",TimerRemove:"TimerRemove",TimerFire:"TimerFire",XHRReadyStateChange:"XHRReadyStateChange",XHRLoad:"XHRLoad",CompileScript:"v8.compile",EvaluateScript:"EvaluateScript",CompileModule:"v8.compileModule",EvaluateModule:"v8.evaluateModule",WasmStreamFromResponseCallback:"v8.wasm.streamFromResponseCallback",WasmCompiledModule:"v8.wasm.compiledModule",WasmCachedModule:"v8.wasm.cachedModule",WasmModuleCacheHit:"v8.wasm.moduleCacheHit",WasmModuleCacheInvalid:"v8.wasm.moduleCacheInvalid",FrameStartedLoading:"FrameStartedLoading",CommitLoad:"CommitLoad",MarkLoad:"MarkLoad",MarkDOMContent:"MarkDOMContent",MarkFirstPaint:"firstPaint",MarkFCP:"firstContentfulPaint",MarkLCPCandidate:"largestContentfulPaint::Candidate",MarkLCPInvalidate:"largestContentfulPaint::Invalidate",NavigationStart:"navigationStart",TimeStamp:"TimeStamp",ConsoleTime:"ConsoleTime",UserTiming:"UserTiming",ResourceWillSendRequest:"ResourceWillSendRequest",ResourceSendRequest:"ResourceSendRequest",ResourceReceiveResponse:"ResourceReceiveResponse",ResourceReceivedData:"ResourceReceivedData",ResourceFinish:"ResourceFinish",ResourceMarkAsCached:"ResourceMarkAsCached",RunMicrotasks:"RunMicrotasks",FunctionCall:"FunctionCall",GCEvent:"GCEvent",MajorGC:"MajorGC",MinorGC:"MinorGC",JSFrame:"JSFrame",JSSample:"JSSample",V8Sample:"V8Sample",JitCodeAdded:"JitCodeAdded",JitCodeMoved:"JitCodeMoved",StreamingCompileScript:"v8.parseOnBackground",StreamingCompileScriptWaiting:"v8.parseOnBackgroundWaiting",StreamingCompileScriptParsing:"v8.parseOnBackgroundParsing",V8Execute:"V8.Execute",UpdateCounters:"UpdateCounters",RequestAnimationFrame:"RequestAnimationFrame",CancelAnimationFrame:"CancelAnimationFrame",FireAnimationFrame:"FireAnimationFrame",RequestIdleCallback:"RequestIdleCallback",CancelIdleCallback:"CancelIdleCallback",FireIdleCallback:"FireIdleCallback",WebSocketCreate:"WebSocketCreate",WebSocketSendHandshakeRequest:"WebSocketSendHandshakeRequest",WebSocketReceiveHandshakeResponse:"WebSocketReceiveHandshakeResponse",WebSocketDestroy:"WebSocketDestroy",EmbedderCallback:"EmbedderCallback",SetLayerTreeId:"SetLayerTreeId",TracingStartedInPage:"TracingStartedInPage",TracingSessionIdForWorker:"TracingSessionIdForWorker",DecodeImage:"Decode Image",ResizeImage:"Resize Image",DrawLazyPixelRef:"Draw LazyPixelRef",DecodeLazyPixelRef:"Decode LazyPixelRef",LazyPixelRef:"LazyPixelRef",LayerTreeHostImplSnapshot:"cc::LayerTreeHostImpl",PictureSnapshot:"cc::Picture",DisplayItemListSnapshot:"cc::DisplayItemList",LatencyInfo:"LatencyInfo",LatencyInfoFlow:"LatencyInfo.Flow",InputLatencyMouseMove:"InputLatency::MouseMove",InputLatencyMouseWheel:"InputLatency::MouseWheel",ImplSideFling:"InputHandlerProxy::HandleGestureFling::started",GCCollectGarbage:"BlinkGC.AtomicPhase",CryptoDoEncrypt:"DoEncrypt",CryptoDoEncryptReply:"DoEncryptReply",CryptoDoDecrypt:"DoDecrypt",CryptoDoDecryptReply:"DoDecryptReply",CryptoDoDigest:"DoDigest",CryptoDoDigestReply:"DoDigestReply",CryptoDoSign:"DoSign",CryptoDoSignReply:"DoSignReply",CryptoDoVerify:"DoVerify",CryptoDoVerifyReply:"DoVerifyReply",CpuProfile:"CpuProfile",Profile:"Profile",AsyncTask:"AsyncTask"};u.Category={Console:"blink.console",UserTiming:"blink.user_timing",LatencyInfo:"latencyInfo",Loading:"loading"},u.WarningType={LongTask:"LongTask",ForcedStyle:"ForcedStyle",ForcedLayout:"ForcedLayout",IdleDeadlineExceeded:"IdleDeadlineExceeded",LongHandler:"LongHandler",LongRecurringHandler:"LongRecurringHandler",V8Deopt:"V8Deopt"},u.WorkerThreadName="DedicatedWorker thread",u.WorkerThreadNameLegacy="DedicatedWorker Thread",u.RendererMainThreadName="CrRendererMain",u.BrowserMainThreadName="CrBrowserMain",u.DevToolsMetadataEvent={TracingStartedInBrowser:"TracingStartedInBrowser",TracingStartedInPage:"TracingStartedInPage",TracingSessionIdForWorker:"TracingSessionIdForWorker",FrameCommittedInBrowser:"FrameCommittedInBrowser",ProcessReadyInBrowser:"ProcessReadyInBrowser",FrameDeletedInBrowser:"FrameDeletedInBrowser"},u.Thresholds={LongTask:50,Handler:150,RecurringHandler:50,ForcedLayout:30,IdleCallbackAddon:5};class p{constructor(){this.name="",this.type=g.Other,this.forMainFrame=!1,this.url="",this.events=[],this.asyncEvents=[],this.tasks=[],this._syncEvents=null,this.thread=null}syncEvents(){if(this.events.length)return this.events;if(this._syncEvents)return this._syncEvents;const e=[];function t(){const t=e[e.length-1];if(void 0!==t){const e=t.endTime;if(void 0!==e)return e}throw new Error("End time does not exist on event.")}this._syncEvents=[];for(const s of this.asyncEvents){const a=s.startTime;let r=s.endTime;for(void 0===r&&(r=a);e.length&&a>=t();)e.pop();if(e.length&&r>t()){this._syncEvents=[];break}const i=new n.Event(s.categoriesString,s.name,n.Phase.Complete,a,s.thread);i.setEndTime(r),i.addArgs(s.args),this._syncEvents.push(i),e.push(i)}return this._syncEvents}}const g={MainThread:Symbol("MainThread"),Worker:Symbol("Worker"),Input:Symbol("Input"),Animation:Symbol("Animation"),Timings:Symbol("Timings"),Console:Symbol("Console"),Raster:Symbol("Raster"),GPU:Symbol("GPU"),Experience:Symbol("Experience"),Other:Symbol("Other")};class T{constructor(e){this.frameId=e.frame,this.url=e.url||"",this.name=e.name,this.children=[],this.parent=null,this.processes=[],this.deletedTime=null,this.ownerNode=null}update(e,t){this.url=t.url||"",this.name=t.name,t.processId?this.processes.push({time:e,processId:t.processId,processPseudoId:"",url:t.url||""}):this.processes.push({time:e,processId:-1,processPseudoId:t.processPseudoId,url:t.url||""})}processReady(e,t){for(const s of this.processes)s.processPseudoId===e&&(s.processPseudoId="",s.processId=t)}addChild(e){this.children.push(e),e.parent=this}}class v{constructor(e){const t=_,s=e.name===t.ResourceSendRequest||e.name===t.ResourceWillSendRequest;this.startTime=s?e.startTime:0,this.endTime=1/0,this.encodedDataLength=0,this.decodedBodyLength=0,this.children=[],this.timing,this.mimeType,this.url,this.requestMethod,this._transferSize=0,this._maybeDiskCached=!1,this._memoryCached=!1,this.addEvent(e)}addEvent(e){this.children.push(e);const t=_;this.startTime=Math.min(this.startTime,e.startTime);const s=e.args.data;s.mimeType&&(this.mimeType=s.mimeType),"priority"in s&&(this.priority=s.priority),e.name===t.ResourceFinish&&(this.endTime=e.startTime),s.finishTime&&(this.finishTime=1e3*s.finishTime),this.responseTime||e.name!==t.ResourceReceiveResponse&&e.name!==t.ResourceReceivedData||(this.responseTime=e.startTime);const a=s.encodedDataLength||0;e.name===t.ResourceMarkAsCached&&(this._memoryCached=!0),e.name===t.ResourceReceiveResponse&&(s.fromCache&&(this._maybeDiskCached=!0),s.fromServiceWorker&&(this.fromServiceWorker=!0),s.hasCachedResource&&(this.hasCachedResource=!0),this.encodedDataLength=a),e.name===t.ResourceReceivedData&&(this.encodedDataLength+=a),e.name===t.ResourceFinish&&a&&(this.encodedDataLength=a,this._transferSize=a);const r=s.decodedBodyLength;e.name===t.ResourceFinish&&r&&(this.decodedBodyLength=r),this.url||(this.url=s.url),this.requestMethod||(this.requestMethod=s.requestMethod),this.timing||(this.timing=s.timing),s.fromServiceWorker&&(this.fromServiceWorker=!0)}cached(){return Boolean(this._memoryCached)||Boolean(this._maybeDiskCached)&&!this._transferSize&&!this.fromServiceWorker}memoryCached(){return this._memoryCached}getSendReceiveTiming(){if(this.cached()||!this.timing)return{sendStartTime:this.startTime,headersEndTime:this.startTime};const e=1e3*this.timing.requestTime;return{sendStartTime:e+this.timing.sendStart,headersEndTime:e+this.timing.receiveHeadersEnd}}getStartTime(){return Math.min(this.startTime,!this.cached()&&this.timing&&1e3*this.timing.requestTime||1/0)}beginTime(){return Math.min(this.getStartTime(),!this.cached()&&this.timing&&1e3*this.timing.pushStart||1/0)}}class f{constructor(e){this.type=e.name,this.startTime=e.startTime,this._tracingEvent=e;const t=e.args.data;this.frame=t.frame,this.nodeId=t.nodeId,this.nodeName=t.nodeName,this.invalidationSet=t.invalidationSet,this.invalidatedSelectorId=t.invalidatedSelectorId,this.changedId=t.changedId,this.changedClass=t.changedClass,this.changedAttribute=t.changedAttribute,this.changedPseudo=t.changedPseudo,this.selectorPart=t.selectorPart,this.extraData=t.extraData,this.invalidationList=t.invalidationList,this.cause={reason:t.reason,stackTrace:t.stackTrace},this.linkedRecalcStyleEvent=!1,this.linkedLayoutEvent=!1,!this.cause.reason&&this.cause.stackTrace&&this.type===_.LayoutInvalidationTracking&&(this.cause.reason="Layout forced")}}class y{constructor(){this._lastRecalcStyle=null,this._lastPaintWithLayer=null,this._didPaint=!1,this._initializePerFrameState(),this._invalidations={},this._invalidationsByNodeId={}}static invalidationEventsFor(e){return k.get(e)||null}addInvalidation(e){if(this._startNewFrameIfNeeded(),!e.nodeId)return console.error("Invalidation lacks node information."),void console.error(e);const t=_;if(e.type===t.StyleRecalcInvalidationTracking&&"StyleInvalidator"===e.cause.reason)return;if(e.type===t.ScheduleStyleInvalidationTracking||e.type===t.StyleInvalidatorInvalidationTracking||e.type===t.StyleRecalcInvalidationTracking){e.startTime&&this._lastRecalcStyle&&void 0!==this._lastRecalcStyle.endTime&&e.startTime>=this._lastRecalcStyle.startTime&&e.startTime<=this._lastRecalcStyle.endTime&&this._associateWithLastRecalcStyleEvent(e)}this._invalidations[e.type]?this._invalidations[e.type].push(e):this._invalidations[e.type]=[e],e.nodeId&&(this._invalidationsByNodeId[e.nodeId]?this._invalidationsByNodeId[e.nodeId].push(e):this._invalidationsByNodeId[e.nodeId]=[e])}didRecalcStyle(e){this._lastRecalcStyle=e;const t=[_.ScheduleStyleInvalidationTracking,_.StyleInvalidatorInvalidationTracking,_.StyleRecalcInvalidationTracking];for(const e of this._invalidationsOfTypes(t))this._associateWithLastRecalcStyleEvent(e)}_associateWithLastRecalcStyleEvent(e){if(e.linkedRecalcStyleEvent)return;const t=_;if(!this._lastRecalcStyle)throw new Error("Last recalculate style event not set.");const s=this._lastRecalcStyle.args.beginData.frame;e.type===t.StyleInvalidatorInvalidationTracking?this._addSyntheticStyleRecalcInvalidations(this._lastRecalcStyle,s,e):e.type===t.ScheduleStyleInvalidationTracking||this._addInvalidationToEvent(this._lastRecalcStyle,s,e),e.linkedRecalcStyleEvent=!0}_addSyntheticStyleRecalcInvalidations(e,t,s){if(s.invalidationList){if(!s.nodeId)return console.error("Invalidation lacks node information."),void console.error(s);for(let e=0;e<s.invalidationList.length;e++){const a=s.invalidationList[e].id;let r;const i=this._invalidationsByNodeId[s.nodeId]||[];for(let e=0;e<i.length;e++){const s=i[e];s.frame===t&&s.invalidationSet===a&&s.type===_.ScheduleStyleInvalidationTracking&&(r=s)}r?this._addSyntheticStyleRecalcInvalidation(r._tracingEvent,s):console.error("Failed to lookup the event that scheduled a style invalidator invalidation.")}}else this._addSyntheticStyleRecalcInvalidation(s._tracingEvent,s)}_addSyntheticStyleRecalcInvalidation(e,t){const s=new f(e);s.type=_.StyleRecalcInvalidationTracking,t.cause.reason&&(s.cause.reason=t.cause.reason),t.selectorPart&&(s.selectorPart=t.selectorPart),this.addInvalidation(s),s.linkedRecalcStyleEvent||this._associateWithLastRecalcStyleEvent(s)}didLayout(e){const t=e.args.beginData.frame;for(const s of this._invalidationsOfTypes([_.LayoutInvalidationTracking]))s.linkedLayoutEvent||(this._addInvalidationToEvent(e,t,s),s.linkedLayoutEvent=!0)}didPaint(e){this._didPaint=!0}_addInvalidationToEvent(e,t,s){if(t!==s.frame)return;const a=k.get(e);a?a.push(s):k.set(e,[s])}_invalidationsOfTypes(e){const t=this._invalidations;return e||(e=Object.keys(t)),function*(){if(e)for(let s=0;s<e.length;++s){const a=t[e[s]]||[];for(let e=0;e<a.length;++e)yield a[e]}}()}_startNewFrameIfNeeded(){this._didPaint&&this._initializePerFrameState()}_initializePerFrameState(){this._invalidations={},this._invalidationsByNodeId={},this._lastRecalcStyle=null,this._lastPaintWithLayer=null,this._didPaint=!1}}class I{constructor(){if(I._initialize(),this._initiatorByType=new Map,I._asyncEvents)for(const e of I._asyncEvents.keys())this._initiatorByType.set(e,new Map)}static _initialize(){if(I._asyncEvents)return;const e=new Map,t=_;e.set(t.TimerInstall,{causes:[t.TimerFire],joinBy:"timerId"}),e.set(t.ResourceSendRequest,{causes:[t.ResourceMarkAsCached,t.ResourceReceiveResponse,t.ResourceReceivedData,t.ResourceFinish],joinBy:"requestId"}),e.set(t.RequestAnimationFrame,{causes:[t.FireAnimationFrame],joinBy:"id"}),e.set(t.RequestIdleCallback,{causes:[t.FireIdleCallback],joinBy:"id"}),e.set(t.WebSocketCreate,{causes:[t.WebSocketSendHandshakeRequest,t.WebSocketReceiveHandshakeResponse,t.WebSocketDestroy],joinBy:"identifier"}),I._asyncEvents=e,I._typeToInitiator=new Map;for(const t of e){const e=t[1].causes;for(const s of e)I._typeToInitiator.set(s,t[0])}}processEvent(e){if(!I._typeToInitiator||!I._asyncEvents)return;let t=I._typeToInitiator.get(e.name);const s=!t;t||(t=e.name);const a=I._asyncEvents.get(t);if(!a)return;const r=u.globalEventId(e,a.joinBy);if(!r)return;const i=this._initiatorByType.get(t);if(i){if(s)return void i.set(r,e);const t=i.get(r),a=S.forEvent(e);a.setInitiator(t||null),!a.frameId&&t&&(a.frameId=u.eventFrameId(t))}}}I._asyncEvents=null,I._typeToInitiator=null;class S{constructor(){this.warning=null,this.previewElement=null,this.url=null,this.backendNodeId=0,this.stackTrace=null,this.picture=null,this._initiator=null,this.frameId="",this.timeWaitingForMainThread}setInitiator(e){if(this._initiator=e,!e||this.url)return;const t=S.forEvent(e).url;t&&(this.url=t)}initiator(){return this._initiator}topFrame(){const e=this.stackTraceForSelfOrInitiator();return e&&e[0]||null}stackTraceForSelfOrInitiator(){return this.stackTrace||this._initiator&&S.forEvent(this._initiator).stackTrace}static forEvent(e){let t=F.get(e);return t||(t=new S,F.set(e,t)),t}}const F=new WeakMap,k=new WeakMap;var R=Object.freeze({__proto__:null,TimelineModelImpl:u,RecordType:_,Track:p,TrackType:g,PageFrame:T,NetworkRequest:v,InvalidationTrackingEvent:f,InvalidationTracker:y,TimelineAsyncEventTracker:I,TimelineData:S,InvalidationCause:undefined,MetadataEvents:undefined});class E{accept(e){return!0}}class C extends E{constructor(e){super(),this._visibleTypes=new Set(e)}accept(e){return this._visibleTypes.has(C._eventType(e))}static _eventType(e){return e.hasCategory(u.Category.Console)?_.ConsoleTime:e.hasCategory(u.Category.UserTiming)?_.UserTiming:e.hasCategory(u.Category.LatencyInfo)?_.LatencyInfo:e.name}}var P=Object.freeze({__proto__:null,TimelineModelFilter:E,TimelineVisibleEventsFilter:C,TimelineInvisibleEventsFilter:class extends E{constructor(e){super(),this._invisibleTypes=new Set(e)}accept(e){return!this._invisibleTypes.has(C._eventType(e))}},ExclusiveNameFilter:class extends E{constructor(e){super(),this._excludeNames=new Set(e)}accept(e){return!this._excludeNames.has(e.name)}}});class M extends d.LayerTreeBase{constructor(e){super(e),this._tileById=new Map,this._paintProfilerModel=e&&e.model(c.PaintProfilerModel)}async setLayers(e,t,s){const a=new Set;if(e)this._extractNodeIdsToResolve(a,{},e);else if(t)for(let e=0;e<t.length;++e)this._extractNodeIdsToResolve(a,{},t[e]);await this.resolveBackendNodeIds(a);const r=this.layersById;if(this.layersById=new Map,this.setContentRoot(null),e){const t=this._innerSetLayers(r,e);this.setRoot(t)}else if(t){const e=t.map(this._innerSetLayers.bind(this,r)),s=this.contentRoot();if(!s)throw new Error("Content root is not set.");this.setRoot(s);for(let t=0;t<e.length;++t)e[t].id()!==s.id()&&s.addChild(e[t])}this._setPaints(s)}setTiles(e){this._tileById=new Map;for(const t of e)this._tileById.set(t.id,t)}pictureForRasterTile(t){const s=this._tileById.get("cc::Tile/"+t);if(!s)return e.Console.instance().error(`Tile ${t} is missing`),Promise.resolve(null);const a=this.layerById(s.layer_id);return a?a._pictureForRect(s.content_rect):(e.Console.instance().error(`Layer ${s.layer_id} for tile ${t} is not found`),Promise.resolve(null))}_setPaints(e){for(let t=0;t<e.length;++t){const s=this.layersById.get(e[t].layerId());s&&s._addPaintEvent(e[t])}}_innerSetLayers(e,t){let s=e.get(t.layer_id);s?s._reset(t):s=new w(this._paintProfilerModel,t),this.layersById.set(t.layer_id,s),t.owner_node&&s._setNode(this.backendNodeIdToNode().get(t.owner_node)||null),!this.contentRoot()&&s.drawsContent()&&this.setContentRoot(s);for(let a=0;t.children&&a<t.children.length;++a)s.addChild(this._innerSetLayers(e,t.children[a]));return s}_extractNodeIdsToResolve(e,t,s){const a=s.owner_node;a&&!this.backendNodeIdToNode().has(a)&&e.add(a);for(let a=0;s.children&&a<s.children.length;++a)this._extractNodeIdsToResolve(e,t,s.children[a])}}class w{constructor(e,t){this._parentLayerId=null,this._parent=null,this._layerId="",this._node=null,this._offsetX=-1,this._offsetY=-1,this._width=-1,this._height=-1,this._children=[],this._quad=[],this._scrollRects=[],this._gpuMemoryUsage=-1,this._paints=[],this._compositingReasonIds=[],this._drawsContent=!1,this._paintProfilerModel=e,this._reset(t)}_reset(e){this._node=null,this._layerId=String(e.layer_id),this._offsetX=e.position[0],this._offsetY=e.position[1],this._width=e.bounds.width,this._height=e.bounds.height,this._children=[],this._parentLayerId=null,this._parent=null,this._quad=e.layer_quad||[],this._createScrollRects(e),this._compositingReasonIds=e.compositing_reason_ids||e.debug_info&&e.debug_info.compositing_reason_ids||[],this._drawsContent=Boolean(e.draws_content),this._gpuMemoryUsage=e.gpu_memory_usage,this._paints=[]}id(){return this._layerId}parentId(){return this._parentLayerId}parent(){return this._parent}isRoot(){return!this.parentId()}children(){return this._children}addChild(e){const t=e;t._parent&&console.assert(!1,"Child already has a parent"),this._children.push(t),t._parent=this,t._parentLayerId=this._layerId}_setNode(e){this._node=e}node(){return this._node}nodeForSelfOrAncestor(){let e=this;for(;e;e=e.parent())if(e.node())return e.node();return null}offsetX(){return this._offsetX}offsetY(){return this._offsetY}width(){return this._width}height(){return this._height}transform(){return null}quad(){return this._quad}anchorPoint(){return[.5,.5,0]}invisible(){return!1}paintCount(){return 0}lastPaintRect(){return null}scrollRects(){return this._scrollRects}stickyPositionConstraint(){return null}gpuMemoryUsage(){return this._gpuMemoryUsage}snapshots(){return this._paints.map((e=>e.snapshotPromise().then((e=>{if(!e)return null;return{rect:{x:e.rect[0],y:e.rect[1],width:e.rect[2],height:e.rect[3]},snapshot:e.snapshot}}))))}_pictureForRect(e){return Promise.all(this._paints.map((e=>e.picturePromise()))).then((s=>{const a=s.filter((s=>{return s&&(a=s.rect,r=e,t(a[0],a[0]+a[2],r[0],r[0]+r[2])&&t(a[1],a[1]+a[3],r[1],r[1]+r[3]));var a,r})).map((e=>({x:e.rect[0],y:e.rect[1],picture:e.serializedPicture})));if(!a.length||!this._paintProfilerModel)return null;const r=a.reduce(((e,t)=>Math.min(e,t.x)),1/0),i=a.reduce(((e,t)=>Math.min(e,t.y)),1/0),n={x:e[0]-r,y:e[1]-i,width:e[2],height:e[3]};return this._paintProfilerModel.loadSnapshotFromFragments(a).then((e=>e?{rect:n,snapshot:e}:null))}));function t(e,t,s,a){return console.assert(e<=t&&s<=a,"segments should be specified as ordered pairs"),t>s&&e<a}}_scrollRectsFromParams(e,t){return{rect:{x:e[0],y:e[1],width:e[2],height:e[3]},type:t}}_createScrollRects(e){const t=[];e.non_fast_scrollable_region&&t.push(this._scrollRectsFromParams(e.non_fast_scrollable_region,d.Layer.ScrollRectType.NonFastScrollable)),e.touch_event_handler_region&&t.push(this._scrollRectsFromParams(e.touch_event_handler_region,d.Layer.ScrollRectType.TouchEventHandler)),e.wheel_event_handler_region&&t.push(this._scrollRectsFromParams(e.wheel_event_handler_region,d.Layer.ScrollRectType.WheelEventHandler)),e.scroll_event_handler_region&&t.push(this._scrollRectsFromParams(e.scroll_event_handler_region,d.Layer.ScrollRectType.RepaintsOnScroll)),this._scrollRects=t}_addPaintEvent(e){this._paints.push(e)}requestCompositingReasonIds(){return Promise.resolve(this._compositingReasonIds)}drawsContent(){return this._drawsContent}}var L=Object.freeze({__proto__:null,TracingLayerTree:M,TracingLayer:w,TracingLayerPayload:undefined,TracingLayerTile:undefined});const b=new WeakMap;class N{constructor(){this._segments,this._drags,this._cssAnimations,this._responses,this._scrolls,this.reset()}static phaseForEvent(e){return b.get(e)}populate(e,t){if(this.reset(),!e)return;this._processInputLatencies(e),t&&this._processAnimations(t);const a=new s.SegmentedRange;a.appendRange(this._drags),a.appendRange(this._cssAnimations),a.appendRange(this._scrolls),a.appendRange(this._responses),this._segments=a.segments()}_processInputLatencies(t){const s=D,r=B,i=N._mergeThresholdsMs;let n,o,l,d,c,h,m;for(let _=0;_<t.length;++_){const p=t[_];_>0&&t[_].startTime<t[_-1].startTime&&console.assert(!1,"Unordered input events");switch(this._inputEventType(p.name)){case s.ScrollBegin:this._scrolls.append(this._segmentForEvent(p,r.Scroll)),n=p;break;case s.ScrollEnd:n?this._scrolls.append(this._segmentForEventRange(n,p,r.Scroll)):this._scrolls.append(this._segmentForEvent(p,r.Scroll)),n=null;break;case s.ScrollUpdate:l=null,this._scrolls.append(this._segmentForEvent(p,r.Scroll));break;case s.FlingStart:if(o){e.Console.instance().error(a.UIString("Two flings at the same time? %s vs %s",o.startTime,p.startTime));break}o=p;break;case s.FlingCancel:if(!o)break;this._scrolls.append(this._segmentForEventRange(o,p,r.Fling)),o=null;break;case s.ImplSideFling:this._scrolls.append(this._segmentForEvent(p,r.Fling));break;case s.ShowPress:case s.Tap:case s.KeyDown:case s.KeyDownRaw:case s.KeyUp:case s.Char:case s.Click:case s.ContextMenu:this._responses.append(this._segmentForEvent(p,r.Response));break;case s.TouchStart:if(l){e.Console.instance().error(a.UIString("Two touches at the same time? %s vs %s",l.startTime,p.startTime));break}l=p,this._setPhaseForEvent(p,r.Response),d=null;break;case s.TouchCancel:l=null;break;case s.TouchMove:d?this._drags.append(this._segmentForEvent(p,r.Drag)):l&&(d=p,this._responses.append(this._segmentForEventRange(l,p,r.Response)));break;case s.TouchEnd:l=null;break;case s.MouseDown:h=p,m=null;break;case s.MouseMove:h&&!m&&h.startTime+i.mouse>p.startTime?(this._responses.append(this._segmentForEvent(h,r.Response)),this._responses.append(this._segmentForEvent(p,r.Response))):h&&this._drags.append(this._segmentForEvent(p,r.Drag)),m=p;break;case s.MouseUp:this._responses.append(this._segmentForEvent(p,r.Response)),h=null;break;case s.MouseWheel:c&&u(i.mouse,c,p)?this._scrolls.append(this._segmentForEventRange(c,p,r.Scroll)):this._scrolls.append(this._segmentForEvent(p,r.Scroll)),c=p}}function u(e,t,s){return void 0!==t.endTime&&(t.endTime<s.startTime&&s.startTime<t.endTime+e)}}_processAnimations(e){for(let t=0;t<e.length;++t)this._cssAnimations.append(this._segmentForEvent(e[t],B.Animation))}_segmentForEvent(e,t){return this._setPhaseForEvent(e,t),new s.Segment(e.startTime,void 0!==e.endTime?e.endTime:Number.MAX_SAFE_INTEGER,t)}_segmentForEventRange(e,t,a){return this._setPhaseForEvent(e,a),this._setPhaseForEvent(t,a),new s.Segment(e.startTime,void 0!==e.endTime?e.endTime:Number.MAX_SAFE_INTEGER,a)}_setPhaseForEvent(e,t){b.set(e.steps[0],t)}interactionRecords(){return this._segments}reset(){const e=N._mergeThresholdsMs;function t(e,t,s){return t.end+e>=s.begin&&t.data===s.data?t:null}this._segments=[],this._drags=new s.SegmentedRange(t.bind(null,e.mouse)),this._cssAnimations=new s.SegmentedRange(t.bind(null,e.animation)),this._responses=new s.SegmentedRange(t.bind(null,0)),this._scrolls=new s.SegmentedRange(t.bind(null,e.animation))}_inputEventType(e){const t="InputLatency::";return e.startsWith(t)?e.substr(t.length):e===D.ImplSideFling?e:(console.error("Unrecognized input latency event: "+e),null)}}const B={Idle:"Idle",Response:"Response",Scroll:"Scroll",Fling:"Fling",Drag:"Drag",Animation:"Animation",Uncategorized:"Uncategorized"},D={Char:"Char",Click:"GestureClick",ContextMenu:"ContextMenu",FlingCancel:"GestureFlingCancel",FlingStart:"GestureFlingStart",ImplSideFling:_.ImplSideFling,KeyDown:"KeyDown",KeyDownRaw:"RawKeyDown",KeyUp:"KeyUp",LatencyScrollUpdate:"ScrollUpdate",MouseDown:"MouseDown",MouseMove:"MouseMove",MouseUp:"MouseUp",MouseWheel:"MouseWheel",PinchBegin:"GesturePinchBegin",PinchEnd:"GesturePinchEnd",PinchUpdate:"GesturePinchUpdate",ScrollBegin:"GestureScrollBegin",ScrollEnd:"GestureScrollEnd",ScrollUpdate:"GestureScrollUpdate",ScrollUpdateRenderer:"ScrollUpdate",ShowPress:"GestureShowPress",Tap:"GestureTap",TapCancel:"GestureTapCancel",TapDown:"GestureTapDown",TouchCancel:"TouchCancel",TouchEnd:"TouchEnd",TouchMove:"TouchMove",TouchStart:"TouchStart"};N._mergeThresholdsMs={animation:1,mouse:40},N._eventIRPhase=Symbol("eventIRPhase");var A=Object.freeze({__proto__:null,TimelineIRModel:N,Phases:B,InputEvents:D});class W{constructor(e){this._categoryMapper=e,this._frames,this._frameById,this._minimumRecordTime,this._lastFrame,this._mainFrameCommitted,this._mainFrameRequested,this._minimumRecordTime,this._lastLayerTree,this._framePendingActivation,this._currentTaskTimeByCategory,this._target,this.reset()}frames(e,t){if(!e&&!t)return this._frames;const s=this._frames.lowerBound(e||0,((e,t)=>e-t.endTime)),a=this._frames.lowerBound(t||1/0,((e,t)=>e-t.startTime));return this._frames.slice(s,a)}hasRasterTile(e){const t=e.args.tileData;if(!t)return!1;const s=t.sourceFrameNumber,a=s&&this._frameById[s];return!(!a||!a.layerTree)}rasterTilePromise(e){if(!this._target)return Promise.resolve(null);const t=e.args.tileData,s=t.sourceFrameNumber,a=t.tileId&&t.tileId.id_ref,r=s&&this._frameById[s];return r&&r.layerTree&&a?r.layerTree.layerTreePromise().then((e=>e&&e.pictureForRasterTile(a))):Promise.resolve(null)}reset(){this._minimumRecordTime=1/0,this._frames=[],this._frameById={},this._lastFrame=null,this._lastLayerTree=null,this._mainFrameCommitted=!1,this._mainFrameRequested=!1,this._framePendingCommit=null,this._lastBeginFrame=null,this._lastDroppedFrame=null,this._lastNeedsBeginFrame=null,this._framePendingActivation=null,this._lastTaskBeginTime=null,this._target=null,this._layerTreeId=null,this._currentTaskTimeByCategory={}}handleBeginFrame(e){this._lastFrame||this._startFrame(e),this._lastBeginFrame=e}handleDroppedFrame(e){this._lastFrame||this._startFrame(e),this._lastDroppedFrame=e}handleDrawFrame(e){if(this._lastFrame){if(this._mainFrameCommitted||!this._mainFrameRequested){if(this._lastNeedsBeginFrame){const e=this._framePendingActivation?this._framePendingActivation.triggerTime:this._lastBeginFrame||this._lastNeedsBeginFrame;e>this._lastFrame.startTime&&(this._lastFrame.idle=!0,this._startFrame(e),this._framePendingActivation&&this._commitPendingFrame(),this._lastBeginFrame=null),this._lastNeedsBeginFrame=null}this._lastDroppedFrame&&(this._lastFrame.dropped=!0,this._startFrame(this._lastDroppedFrame),this._lastDroppedFrame=null),this._startFrame(e)}this._mainFrameCommitted=!1}else this._startFrame(e)}handleActivateLayerTree(){this._lastFrame&&this._framePendingActivation&&!this._lastNeedsBeginFrame&&this._commitPendingFrame()}handleRequestMainThreadFrame(){this._lastFrame&&(this._mainFrameRequested=!0)}handleCompositeLayers(){this._framePendingCommit&&(this._framePendingActivation=this._framePendingCommit,this._framePendingCommit=null,this._mainFrameRequested=!1,this._mainFrameCommitted=!0)}handleLayerTreeSnapshot(e){this._lastLayerTree=e}handleNeedFrameChanged(e,t){t&&(this._lastNeedsBeginFrame=e)}_startFrame(e){this._lastFrame&&this._flushFrame(this._lastFrame,e),this._lastFrame=new G(e,e-this._minimumRecordTime)}_flushFrame(e,t){e._setLayerTree(this._lastLayerTree),e._setEndTime(t),this._lastLayerTree&&this._lastLayerTree._setPaints(e._paints);const s=this._frames[this._frames.length-1];this._frames.length&&s&&(e.startTime!==s.endTime||e.startTime>e.endTime)&&console.assert(!1,`Inconsistent frame time for frame ${this._frames.length} (${e.startTime} - ${e.endTime})`),this._frames.push(e),"number"==typeof e._mainFrameId&&(this._frameById[e._mainFrameId]=e)}_commitPendingFrame(){this._framePendingActivation&&this._lastFrame&&(this._lastFrame._addTimeForCategories(this._framePendingActivation.timeByCategory),this._lastFrame._paints=this._framePendingActivation.paints,this._lastFrame._mainFrameId=this._framePendingActivation.mainFrameId,this._framePendingActivation=null)}addTraceEvents(e,t,s){this._target=e;let a=0;this._currentProcessMainThread=s.length&&s[0].thread||null;for(let e=0;e<t.length;++e){for(;a+1<s.length&&s[a+1].time<=t[e].startTime;)this._currentProcessMainThread=s[++a].thread;this._addTraceEvent(t[e])}this._currentProcessMainThread=null}_addTraceEvent(e){const t=_;if(e.startTime&&e.startTime<this._minimumRecordTime&&(this._minimumRecordTime=e.startTime),e.name===t.SetLayerTreeId)this._layerTreeId=e.args.layerTreeId||e.args.data.layerTreeId;else if(e.id&&e.phase===n.Phase.SnapshotObject&&e.name===t.LayerTreeHostImplSnapshot&&Number(e.id)===this._layerTreeId&&this._target){const t=e;this.handleLayerTreeSnapshot(new x(this._target,t))}else this._processCompositorEvents(e),e.thread===this._currentProcessMainThread?this._addMainThreadTraceEvent(e):this._lastFrame&&e.selfTime&&!n.TracingModel.isTopLevelEvent(e)&&this._lastFrame._addTimeForCategory(this._categoryMapper(e),e.selfTime)}_processCompositorEvents(e){const t=_;if(e.args.layerTreeId!==this._layerTreeId)return;const s=e.startTime;e.name===t.BeginFrame?this.handleBeginFrame(s):e.name===t.DrawFrame?this.handleDrawFrame(s):e.name===t.ActivateLayerTree?this.handleActivateLayerTree():e.name===t.RequestMainThreadFrame?this.handleRequestMainThreadFrame():e.name===t.NeedsBeginFrameChanged?this.handleNeedFrameChanged(s,e.args.data&&e.args.data.needsBeginFrame):e.name===t.DroppedFrame&&this.handleDroppedFrame(s)}_addMainThreadTraceEvent(e){const t=_;n.TracingModel.isTopLevelEvent(e)&&(this._currentTaskTimeByCategory={},this._lastTaskBeginTime=e.startTime),!this._framePendingCommit&&W._mainFrameMarkers.indexOf(e.name)>=0&&(this._framePendingCommit=new q(this._lastTaskBeginTime||e.startTime,this._currentTaskTimeByCategory)),this._framePendingCommit?(this._addTimeForCategory(this._framePendingCommit.timeByCategory,e),e.name===t.BeginMainThreadFrame&&e.args.data&&e.args.data.frameId&&(this._framePendingCommit.mainFrameId=e.args.data.frameId),e.name===t.Paint&&e.args.data.layerId&&S.forEvent(e).picture&&this._target&&this._framePendingCommit.paints.push(new U(e,this._target)),e.name===t.CompositeLayers&&e.args.layerTreeId===this._layerTreeId&&this.handleCompositeLayers()):this._addTimeForCategory(this._currentTaskTimeByCategory,e)}_addTimeForCategory(e,t){if(!t.selfTime)return;const s=this._categoryMapper(t);e[s]=(e[s]||0)+t.selfTime}}W._mainFrameMarkers=[_.ScheduleStyleRecalculation,_.InvalidateLayout,_.BeginMainThreadFrame,_.ScrollLayer];class x{constructor(e,t){this._target=e,this._snapshot=t,this._paints}async layerTreePromise(){const e=await this._snapshot.objectPromise();if(!e)return null;const t=e.device_viewport_size,s=e.active_tiles,a=e.active_tree.root_layer,r=e.active_tree.layers,i=new M(this._target);return i.setViewportSize(t),i.setTiles(s),await i.setLayers(a,r,this._paints||[]),i}paints(){return this._paints||[]}_setPaints(e){this._paints=e}}class G{constructor(e,t){this.startTime=e,this.startTimeOffset=t,this.endTime=this.startTime,this.duration=0,this.timeByCategory={},this.cpuTime=0,this.idle=!1,this.dropped=!1,this.layerTree=null,this._paints=[],this._mainFrameId=void 0}hasWarnings(){return!1}_setEndTime(e){this.endTime=e,this.duration=this.endTime-this.startTime}_setLayerTree(e){this.layerTree=e}_addTimeForCategories(e){for(const t in e)this._addTimeForCategory(t,e[t])}_addTimeForCategory(e,t){this.timeByCategory[e]=(this.timeByCategory[e]||0)+t,this.cpuTime+=t}}class U{constructor(e,t){this._event=e,this._target=t}layerId(){return this._event.args.data.layerId}event(){return this._event}picturePromise(){const e=S.forEvent(this._event).picture;return e?e.objectPromise().then((e=>{if(!e)return null;const t=e.params&&e.params.layer_rect,s=e.skp64;return t&&s?{rect:t,serializedPicture:s}:null})):Promise.resolve(null)}async snapshotPromise(){const e=this._target&&this._target.model(c.PaintProfilerModel),t=await this.picturePromise();if(!t||!e)return null;const s=await e.loadSnapshot(t.serializedPicture);return s?{rect:t.rect,snapshot:s}:null}}class q{constructor(e,t){this.timeByCategory=t,this.paints=[],this.mainFrameId=void 0,this.triggerTime=e}}var H=Object.freeze({__proto__:null,TimelineFrameModel:W,TracingFrameLayerTree:x,TimelineFrame:G,LayerPaintEvent:U,PendingFrame:q});class z{constructor(e,t){this.totalTime=0,this.selfTime=0,this.id=e,this.event=t,this.parent,this._groupId="",this._isGroupNode=!1,this._depth=0}isGroupNode(){return this._isGroupNode}hasChildren(){throw"Not implemented"}setHasChildren(e){throw"Not implemented"}children(){throw"Not implemented"}searchTree(e,t){t=t||[],this.event&&e(this.event)&&t.push(this);for(const s of this.children().values())s.searchTree(e,t);return t}}class O extends z{constructor(e,t,s){super(e,t),this._root=s&&s._root,this._hasChildren=!1,this._children=null,this.parent=s}hasChildren(){return this._hasChildren}setHasChildren(e){this._hasChildren=e}children(){return this._children||this._buildChildren()}_buildChildren(){const e=[];for(let t=this;t.parent&&!t._isGroupNode;t=t.parent)e.push(t);e.reverse();const t=new Map,s=this,a=this._root;if(!a)return this._children=t,this._children;const r=a._startTime,i=a._endTime,n=a._doNotAggregate?function(t){++d,c===e.length&&d<=e.length+2&&m(t,0);--d}:void 0,o=a._doNotAggregate?void 0:V,l=a._eventGroupIdCallback;let d=0,c=0,h=null;function m(a,r){if(d===e.length+2){if(!h)return;return h.setHasChildren(!0),void(h.selfTime-=r)}let i,n="";o?(i=o(a),n=l?l(a):"",n&&(i+="/"+n)):i=Symbol("uniqueId");let c=t.get(i);c||(c=new O(i,a,s),c._groupId=n,t.set(i,c)),c.selfTime+=r,c.totalTime+=r,h=c}return u.forEachEvent(a._events,(function(t){if(++d,d>e.length+2)return;if(!function(t){if(c===e.length)return!0;if(c!==d-1)return!1;if(!t.endTime)return!1;if(!o)return t===e[c].event&&++c,!1;let s=o(t);const a=l?l(t):"";a&&(s+="/"+a);s===e[c].id&&++c;return!1}(t))return;const s=(void 0!==t.endTime?Math.min(t.endTime,i):i)-Math.max(r,t.startTime);s<0&&console.error("Negative event duration");m(t,s)}),(function(e){--d,c>d&&(c=d)}),n,r,i,a._filter),this._children=t,t}}class $ extends z{constructor(e,t,s){super(e,s),this._children=new Map,this.parent=t,this._isGroupNode=!0}addChild(e,t,s){this._children.set(e.id,e),this.selfTime+=t,this.totalTime+=s,e.parent=this}hasChildren(){return!0}children(){return this._children}}class j extends z{constructor(e,t,s,a,r){super(t,s),this.parent=r,this._root=e,this._depth=(r._depth||0)+1,this._cachedChildren=null,this._hasChildren=a}hasChildren(){return this._hasChildren}setHasChildren(e){this._hasChildren=e}children(){if(this._cachedChildren)return this._cachedChildren;const e=[0],t=[],s=[],a=new Map,r=this._root._startTime,i=this._root._endTime;let n=r;const o=this;return u.forEachEvent(this._root._events,(function(a){const n=(void 0!==a.endTime?Math.min(a.endTime,i):i)-Math.max(a.startTime,r);n<0&&console.assert(!1,"Negative duration of an event");e[e.length-1]-=n,e.push(n);const o=V(a);t.push(o),s.push(a)}),(function(r){const l=e.pop(),d=t.pop();let c;for(s.pop(),c=o;c._depth>1;c=c.parent)if(c.id!==t[t.length+1-c._depth])return;if(c.id!==d||t.length<o._depth)return;const h=t[t.length-o._depth];if(c=a.get(h),!c){const e=s[s.length-o._depth],t=s.length>o._depth;c=new j(o._root,h,e,t,o),a.set(h,c)}const m=void 0!==r.endTime?Math.min(r.endTime,i):i,u=m-Math.max(r.startTime,n);c.selfTime+=l||0,c.totalTime+=u,n=m}),void 0,r,i,this._root._filter),this._cachedChildren=this._root._filterChildren(a),this._cachedChildren}searchTree(e,t){return t=t||[],this.event&&e(this.event)&&t.push(this),t}}function J(e){return e.name===_.JSFrame?e.args.data||null:S.forEvent(e).topFrame()}function V(e){if(e.name===_.TimeStamp)return`${e.name}:${e.args.data.message}`;if(e.name!==_.JSFrame)return e.name;const t=e.args.data,s=t.scriptId||t.url||"",a=t.functionName;return`f:${h.isNativeRuntimeFrame(t)?h.nativeGroup(a)||a:`${a}:${t.lineNumber}:${t.columnNumber}`}@${s}`}var X=Object.freeze({__proto__:null,Node:z,TopDownNode:O,TopDownRootNode:class extends O{constructor(e,t,s,a,r,i){super("",null,null),this._root=this,this._events=e,this._filter=e=>t.every((t=>t.accept(e))),this._startTime=s,this._endTime=a,this._eventGroupIdCallback=i,this._doNotAggregate=r,this.totalTime=a-s,this.selfTime=this.totalTime}children(){return this._children||this._grouppedTopNodes()}_grouppedTopNodes(){const e=super.children();for(const t of e.values())this.selfTime-=t.totalTime;if(!this._eventGroupIdCallback)return e;const t=new Map;for(const s of e.values()){const e=this._eventGroupIdCallback(s.event);let a=t.get(e);a||(a=new $(e,this,s.event),t.set(e,a)),a.addChild(s,s.selfTime,s.totalTime)}return this._children=t,t}},BottomUpRootNode:class extends z{constructor(e,t,s,a,r,i){super("",null),this._children=null,this._events=e,this._textFilter=t,this._filter=e=>s.every((t=>t.accept(e))),this._startTime=a,this._endTime=r,this._eventGroupIdCallback=i,this.totalTime=r-a}hasChildren(){return!0}_filterChildren(e){for(const[t,s]of e)s.event&&!this._textFilter.accept(s.event)&&e.delete(t);return e}children(){return this._children||(this._children=this._filterChildren(this._grouppedTopNodes())),this._children}_ungrouppedTopNodes(){const e=this,t=this._startTime,s=this._endTime,a=new Map,r=[s-t],i=[],n=new Map;u.forEachEvent(this._events,(function(e){const a=(void 0!==e.endTime?Math.min(e.endTime,s):s)-Math.max(e.startTime,t);r[r.length-1]-=a,r.push(a);const o=V(e),l=!n.has(o);l&&n.set(o,a);i.push(l)}),(function(t){const s=V(t);let o=a.get(s);o||(o=new j(e,s,t,!1,e),a.set(s,o));o.selfTime+=r.pop()||0,i.pop()&&(o.totalTime+=n.get(s)||0,n.delete(s));i.length&&o.setHasChildren(!0)}),void 0,t,s,this._filter),this.selfTime=r.pop()||0;for(const e of a)e[1].selfTime<=0&&a.delete(e[0]);return a}_grouppedTopNodes(){const e=this._ungrouppedTopNodes();if(!this._eventGroupIdCallback)return e;const t=new Map;for(const s of e.values()){const e=this._eventGroupIdCallback(s.event);let a=t.get(e);a||(a=new $(e,this,s.event),t.set(e,a)),a.addChild(s,s.selfTime,s.selfTime)}return t}},GroupNode:$,BottomUpNode:j,eventURL:function(e){const t=e.args.data||e.args.beginData;if(t&&t.url)return t.url;let s=J(e);for(;s;){const e=s.url;if(e)return e;s=s.parent}return null},eventStackFrame:J,_eventId:V,ChildrenCache:undefined});export{H as TimelineFrameModel,A as TimelineIRModel,m as TimelineJSProfile,R as TimelineModel,P as TimelineModelFilter,X as TimelineProfileTree,L as TracingLayerTree};
